/*--------------------------------------------------------------*\
		module	:	EDS-API.c
		purpose :	X-Send EditSend API
		author	:	_@ Kengo Jinno
		create	:	2001/09/19
		update	:	2001/09/19
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"EDS-API.h"

static	const	TCHAR	BASED_CODE	szEditSendDllName[] = _T("EditSend.dll");
static	const	TCHAR	BASED_CODE	szEdsInitWindow[] =       _T("EdsInitWindow");
static	const	TCHAR	BASED_CODE	szEdsInitWindowDialog[] = _T("EdsInitWindowDialog");
static	const	TCHAR	BASED_CODE	szEdsInitParamDialog[] =  _T("EdsInitParamDialog");
static	const	TCHAR	BASED_CODE	szEdsGetParam[] =         _T("EdsGetParam");
static	const	TCHAR	BASED_CODE	szEdsGetDefaultParam[] =  _T("EdsGetDefaultParam");
static	const	TCHAR	BASED_CODE	szEdsSendString[] =       _T("EdsSendString");
static	const	TCHAR	BASED_CODE	szEdsWriteProfile[] =     _T("EdsWriteProfile");
static	const	TCHAR	BASED_CODE	szEdsGetProfile[] =       _T("EdsGetProfile");

/*		*/
BOOL	InitEdsApi( NpEdsApiInfoType pInfo )
{
	TCHAR	szPath1[ _MAX_PATH ], szPath2[ _MAX_PATH ];
	LPTSTR	q = szPath2;
	
	/*	̎st@C̃pX	*/
	GetModuleFileName( NULL, szPath1, _MAX_PATH );
	GetShortPathName( szPath1, szPath1, _MAX_PATH );
	/*	t@C"xsd.exe"ɒu	*/
	if( GetFullPathName( szPath1, _MAX_PATH, szPath2, &q ) > 0 ) {
		lstrcpy( q, szEditSendDllName );
	} else {
		lstrcpy( szPath2, szEditSendDllName );
	}
	
	pInfo->hInstDll = LoadLibraryEx( szPath2, NULL, 0 );
	if( pInfo->hInstDll == NULL ) {
		return FALSE;
	}
	
	/*	API֐̃AhX擾	*/
	pInfo->lpEdsInitWindow =       (LP_FUNC_EDSINITWINDOW)      GetProcAddress( pInfo->hInstDll, szEdsInitWindow );
	pInfo->lpEdsInitWindowDialog = (LP_FUNC_EDSINITWINDOWDIALOG)GetProcAddress( pInfo->hInstDll, szEdsInitWindowDialog );
	pInfo->lpEdsInitParamDialog =  (LP_FUNC_EDSINITPARAMDIALOG) GetProcAddress( pInfo->hInstDll, szEdsInitParamDialog );
	pInfo->lpEdsGetParam =         (LP_FUNC_EDSGETPARAM)        GetProcAddress( pInfo->hInstDll, szEdsGetParam );
	pInfo->lpEdsGetDefaultParam =  (LP_FUNC_EDSGETDEFAULTPARAM) GetProcAddress( pInfo->hInstDll, szEdsGetDefaultParam );
	pInfo->lpEdsSendString =       (LP_FUNC_EDSSENDSTRING)      GetProcAddress( pInfo->hInstDll, szEdsSendString );
	pInfo->lpEdsWriteProfile =     (LP_FUNC_EDSWRITEPROFILE)    GetProcAddress( pInfo->hInstDll, szEdsWriteProfile );
	pInfo->lpEdsGetProfile =       (LP_FUNC_EDSGETPROFILE)      GetProcAddress( pInfo->hInstDll, szEdsGetProfile );
	
	if( pInfo->lpEdsInitWindow == NULL ||
		pInfo->lpEdsInitWindowDialog == NULL ||
		pInfo->lpEdsInitParamDialog == NULL ||
		pInfo->lpEdsGetParam == NULL ||
		pInfo->lpEdsGetDefaultParam == NULL ||
		pInfo->lpEdsSendString == NULL ||
		pInfo->lpEdsWriteProfile == NULL ||
		pInfo->lpEdsGetProfile == NULL ) {
		FreeLibrary( pInfo->hInstDll );
		pInfo->hInstDll = NULL;
		return FALSE;
	}
	
	pInfo->hWndTarget = NULL;
	
	pInfo->EdsParam.dwStructSize = sizeof(pInfo->EdsParam);
	(pInfo->lpEdsGetDefaultParam)( &(pInfo->EdsParam) );
	(pInfo->lpEdsInitWindow)( pInfo->hWndTarget );
	
	return TRUE;
}

/*	I	*/
void	QuitEdsApi( NpEdsApiInfoType pInfo )
{
	if( pInfo->hInstDll != NULL ) {
		FreeLibrary( pInfo->hInstDll );
		pInfo->hInstDll = NULL;
	}
	pInfo->hWndTarget = NULL;
	pInfo->lpEdsInitWindow = NULL;
	pInfo->lpEdsInitWindowDialog = NULL;
	pInfo->lpEdsInitParamDialog = NULL;
	pInfo->lpEdsGetParam = NULL;
	pInfo->lpEdsGetDefaultParam = NULL;
	pInfo->lpEdsSendString = NULL;
	pInfo->lpEdsWriteProfile = NULL;
	pInfo->lpEdsGetProfile = NULL;
}
