/*--------------------------------------------------------------*\
		module	:	FileMru.c
		purpose :	t@C
		author	:	_@ Kengo Jinno
		create	:	2001/09/05
		update	:	2001/09/06
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"FileMru.h"
#include	"resource.h"

BOOL	AddFileMruList( FileMru* p, LPCTSTR lpszFilePath, HMENU hMenu )
{
	int		i;
	int		nLoc;
	
	/*	T	*/
	for( i = 0; i < p->nSize; i++ ) {
		if( lstrcmpi( p->szFilePath[i], lpszFilePath ) == 0 ) {
			break;
		}
	}
	nLoc = i;
	
	/*	l߂	*/
	for( i = nLoc; i > 0; i-- ) {
		if( i < MAX_FILE_MRU_CNT ) {
			lstrcpy( p->szFilePath[i], p->szFilePath[i-1] );
		}
	}
	
	/*	擪ɓ	*/
	lstrcpy( p->szFilePath[0], lpszFilePath );
	if( nLoc == p->nSize ) {
		if( ++(p->nSize) > MAX_FILE_MRU_CNT ) {
			p->nSize = MAX_FILE_MRU_CNT;
		}
	}
	
	return UpdateFileMruMenu( p, hMenu );
}

LPCTSTR	GetMruFileName( const FileMru* p, int n )
{
	if( n >= 0 && n < p->nSize ) {
		return p->szFilePath[n];
		/*
			̖߂l̂܂AddFileMruList()ɓnĂ͂ȂB
			RFяȂȂ̂ŁB
		*/
	}
	return _T("");
}

BOOL	UpdateFileMruMenu( const FileMru* p, HMENU hMenu )
{
	int		i, cnt, pos;
	TCHAR	buff[ _MAX_PATH * 2 ];
	TCHAR	path[ _MAX_PATH ];
	LPTSTR	q;
	LPCTSTR	r;
	
	if( p->nSize <= 0 ) {
		return TRUE;
	}
	
	/*	܂Aǂ̈ʒuׂ	*/
	cnt = GetMenuItemCount( hMenu );
	pos = -1;
	for( i = 0; i < cnt; i++ ) {
		if( GetMenuItemID( hMenu, i ) == ID_FILE_MRU_FILE1 ) {
			pos = i;
			break;
		}
	}
	if( pos < 0 ) {
		return FALSE;
	}
	
	/*	̂폜	*/
	for( i = 0; i < MAX_FILE_MRU_CNT; i++ ) {
		DeleteMenu( hMenu, ID_FILE_MRU_FILE1+i, MF_BYCOMMAND );
	}
	
	/*	ǉ	*/
	for( i = 0; i < p->nSize; i++ ) {
#ifdef	WIN32
		/*	PathCompactPathEx()	*/
		if( !p->bNoCompactPath &&
			p->lpPathCompactPathEx != NULL &&
			(*(p->lpPathCompactPathEx))( path, p->szFilePath[i], 51, 0 ) ) {
			;	//	OK
		} else {
			lstrcpy( path, p->szFilePath[i] );
		}
#else
		lstrcpy( path, p->szFilePath[i] );
#endif
		/*	t@C'&'΁A'&&'ƂăZbg	*/
		wsprintf( buff, _T("&%d "), (i+1)%10 );
		q = buff + lstrlen(buff);
		r = path;
		while( *r != _T('\0') ) {
			if( *r == _T('&') ) {
				*(q++) = _T('&');
			}
			*(q++) = *(r++);
		}
		*q = _T('\0');
		InsertMenu( hMenu, pos+i, MF_BYPOSITION|MF_STRING, ID_FILE_MRU_FILE1+i, buff );
	}
	return TRUE;
}

static	const	TCHAR	BASED_CODE	szEntry[] = _T("MRU%d");
#ifdef	WIN32
static	const	TCHAR	BASED_CODE	szNoCompactPathEntry[] = _T("NoCompactPath");
#endif

BOOL	WriteFileMruProfile( const FileMru* p, LPCTSTR lpszSection, LPCTSTR lpszProfile )
{
	TCHAR	buff[ 20 ];
	LPCTSTR	pFile;
	int		i;
	for( i = 0; i < MAX_FILE_MRU_CNT; i++ ) {
		wsprintf( buff, szEntry, i+1 );
		if( i < p->nSize ) {
			pFile = p->szFilePath[i];
		} else {
			pFile = NULL;
		}
		WritePrivateProfileString( lpszSection, buff, pFile, lpszProfile );
	}
	return TRUE;
}

BOOL	GetFileMruProfile( FileMru* p, LPCTSTR lpszSection, LPCTSTR lpszProfile )
{
	TCHAR	buff[ 20 ];
	int		i;
	p->nSize = 0;
	for( i = 0; i < MAX_FILE_MRU_CNT; i++ ) {
		wsprintf( buff, szEntry, i+1 );
		GetPrivateProfileString( lpszSection, buff, _T(""), p->szFilePath[p->nSize], _MAX_PATH, lpszProfile );
		if( p->szFilePath[p->nSize][0] != _T('\0') ) {
			(p->nSize)++;
		}
	}
#ifdef	WIN32
	p->bNoCompactPath = (BOOL)GetPrivateProfileInt( lpszSection, szNoCompactPathEntry, (int)p->bNoCompactPath, lpszProfile );
#endif
	return TRUE;
}

BOOL	InitFileMru( FileMru* p )
{
	int		i;
	p->nSize = 0;
	for( i = 0; i < MAX_FILE_MRU_CNT; i++ ) {
		p->szFilePath[i][0] = _T('\0');
	}
#ifdef	WIN32
	{
		LPCTSTR	lpszDllName = _T("shlwapi.dll");
		p->bNoCompactPath = FALSE;
		p->lpPathCompactPathEx = NULL;
		p->bMustFreeShlWapiDll = FALSE;
		p->hInstShlWapiDll = GetModuleHandle( lpszDllName );
		if( p->hInstShlWapiDll == NULL ) {
			p->hInstShlWapiDll = LoadLibraryEx( lpszDllName, NULL, 0 );
			p->bMustFreeShlWapiDll = ( p->hInstShlWapiDll != NULL );
		}
		if( p->hInstShlWapiDll != NULL ) {
#ifdef UNICODE
			LPCTSTR	lpszFuncName = _T("PathCompactPathExW");
#else
			LPCTSTR	lpszFuncName = _T("PathCompactPathExA");
#endif
			p->lpPathCompactPathEx = (LP_FUNC_PATHCOMPACTPATHEX)GetProcAddress( p->hInstShlWapiDll, lpszFuncName );
		}
	}
#endif
	return TRUE;
}

BOOL	QuitFileMru( FileMru* p )
{
#ifdef	WIN32
	if( p->bMustFreeShlWapiDll && p->hInstShlWapiDll != NULL ) {
		FreeLibrary( p->hInstShlWapiDll );
	}
	p->hInstShlWapiDll = NULL;
	p->bMustFreeShlWapiDll = FALSE;
	p->lpPathCompactPathEx = NULL;
#endif
	return TRUE;
}
