/*--------------------------------------------------------------*\
		module	:	HOOK.c
		purpose :	X-Send etbN
		author	:	_@ Kengo Jinno
		create	:	2001/09/17
		update	:	2001/10/09
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"HOOK.h"


static	HHOOK	hHookCallWnd = NULL;	/*	CALLWNDtbNvV[W	*/
static	HHOOK	hHookKeyboard = NULL;	/*	KEYBOARDtbNvV[W	*/
static	HHOOK	hHookMouse = NULL;		/*	MOUSEtbNvV[W	*/
static	NpIdleInfoType	pIdleInfo = NULL;

/*	CALLWNDtbNvV[W	*/
LRESULT	MYEXPORT	CALLBACK	MyCallWndProc( int nCode, WPARAM wParam, LPARAM lParam )
{
	CWPSTRUCT*	cwps = (CWPSTRUCT*)lParam;
	if( nCode >= 0 && ( cwps->message == WM_INITDIALOG || cwps->message == WM_CENTER_PARENT ) ) {
		/*	_CAOeEBhE̒SɎĂ	*/
		HWND	hWnd = cwps->hwnd;
		HWND	hParent = GetParent( hWnd );
		RECT	rectParent, rect, rectScreen;
		int		x, y;
		if( hParent == NULL ) {
			hParent = GetDesktopWindow();
		}
		GetWindowRect( hParent, &rectParent );
		GetWindowRect( hWnd, &rect );
		rectScreen.left = 0;
		rectScreen.top = 0;
		rectScreen.right = GetSystemMetrics(SM_CXSCREEN);
		rectScreen.bottom = GetSystemMetrics(SM_CYSCREEN);
		x = ( rectParent.left + rectParent.right ) / 2 - ( rect.right - rect.left ) / 2;
		y = ( rectParent.top + rectParent.bottom ) / 2 - ( rect.bottom - rect.top ) / 2;
		if( x < 0 ) {
			x = 0;
		} else if ( x + rect.right - rect.left > rectScreen.right ) {
			x = rectScreen.right - ( rect.right - rect.left );
		}
		if( y < 0 ) {
			y = 0;
		} else if( y + rect.bottom - rect.top > rectScreen.bottom ) {
			y = rectScreen.bottom - ( rect.bottom - rect.top );
		}
		SetWindowPos( hWnd, NULL, x, y, 0, 0, SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);
	}
	return CallNextHookEx( hHookCallWnd, nCode, wParam, lParam );
}

/*	KEYBOARDtbNvV[W	*/
LRESULT	MYEXPORT	CALLBACK	MyKeyboardProc( int nCode, WPARAM wParam, LPARAM lParam )
{
	if( nCode >= 0 && pIdleInfo != NULL ) {
		pIdleInfo->bIsIdle = FALSE;
		pIdleInfo->dwLastTick = GetTickCount();
	}
	return CallNextHookEx( hHookKeyboard, nCode, wParam, lParam );
}

/*	MOUSEtbNvV[W	*/
LRESULT	MYEXPORT	CALLBACK	MyMouseProc( int nCode, WPARAM wParam, LPARAM lParam )
{
	if( nCode >= 0 && pIdleInfo != NULL ) {
		if( wParam == WM_MOUSEMOVE || wParam == WM_NCMOUSEMOVE ) {
			/*	Ȃ	*/
		} else {
			pIdleInfo->bIsIdle = FALSE;
			pIdleInfo->dwLastTick = GetTickCount();
		}
	}
	return CallNextHookEx( hHookMouse, nCode, wParam, lParam );
}

/*	tbNݒ肷	*/
void	InstallHook( NpIdleInfoType pInfo )
{
	DWORD	dwThreadID = GetCurrentThreadId();
	if( hHookCallWnd == NULL ) {
		hHookCallWnd = SetWindowsHookEx( WH_CALLWNDPROC, MyCallWndProc, NULL, dwThreadID );
	}
	if( hHookKeyboard == NULL ) {
		hHookKeyboard = SetWindowsHookEx( WH_KEYBOARD, MyKeyboardProc, NULL, dwThreadID );
	}
	if( hHookMouse == NULL ) {
		hHookMouse = SetWindowsHookEx( WH_MOUSE, MyMouseProc, NULL, dwThreadID );
	}
	if( pInfo != NULL ) {
		pIdleInfo = pInfo;
		pIdleInfo->bIsIdle = FALSE;
		pIdleInfo->dwLastTick = GetTickCount();
	}
}

/*	tbN	*/
void	RemoveHook( void )
{
	if( hHookCallWnd != NULL ) {
		UnhookWindowsHookEx( hHookCallWnd );
		hHookCallWnd = NULL;
	}
	if( hHookKeyboard != NULL ) {
		UnhookWindowsHookEx( hHookKeyboard );
		hHookKeyboard = NULL;
	}
	if( hHookMouse != NULL ) {
		UnhookWindowsHookEx( hHookMouse );
		hHookMouse = NULL;
	}
}
