/*--------------------------------------------------------------*\
		module	:	IPC.h
		purpose :	X-Send vZXԒʐM
		author	:	_@ Kengo Jinno
		create	:	2001/09/10
		update	:	2001/10/04
					2002/03/06	XS_IPC_CMD_MARK_AS_COMMENT ǉ
					2002/03/19	XsInfo::bEditMode ǉ
					2002/04/09	XS_IPC_CMD_SHOW_EDGE 
								XS_IPC_CMD_EDGE_COLUMN ǉ
					2011/02/10	XS_IPC_CMD_SHOW_EDGE,COLUMN 
								ShowCaption() 
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"IPC.h"
#include	"X-Send.h"
#include	"MyEdit.h"
#include	"MyList.h"
#include	"Tools.h"
#include	"ToolBar.h"
#include	"MySci.h"
#include	"Command.h"

/*	X-Sendɒʒm	*/
void	DoXsIpcNotify( HWND hWnd, WORD wItem, WORD wParam )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	if( p != NULL ) {
		PostMessage( HWND_BROADCAST, p->uXsIpcMessage, (WPARAM)hWnd, MAKELPARAM( wItem, wParam ) );
		/*
			Iɂ́AEBhE񋓂āANX̂ɂ
			|Xg悤ɂ邩B
		*/
	}
}

/*	()X-Send痈ʒm̏	*/
LRESULT	XsIpcMsgProc( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	NpXsInfo	p = GetXsInfo( hWnd );
	HWND	hWndFrom = (HWND)wParam;
	int		nCmd = LOWORD( lParam );
	int		nParam = HIWORD( lParam );
	LRESULT	ret = 0;
	
	if( p != NULL ) {
		switch( nCmd ) {
		case XS_IPC_CMD_ADD_MRU:	/*	ɒǉ	*/
			if( nParam == XS_IPC_PARAM_ADD_MRU_NOTIFY ) {
				if( hWndFrom != hWnd ) {
					/*	uǉvƂʒm̂ŁAt@C₢킹	*/
					PostMessage( hWndFrom, p->uXsIpcMessage, (WPARAM)hWnd, MAKELPARAM( XS_IPC_CMD_ADD_MRU, XS_IPC_PARAM_ADD_MRU_QUERY ) );
				}
			} else if( nParam == XS_IPC_PARAM_ADD_MRU_QUERY ) {
				/*	t@C̖₢킹ɉ	*/
				COPYDATASTRUCT	cds;
				ZeroMemory( &cds, sizeof(cds) );
				cds.dwData = (DWORD)MAKELONG( p->uXsIpcMessage, XS_IPC_CMD_ADD_MRU );
				cds.cbData = sizeof(TCHAR) * ( lstrlen( p->szFilePath ) + 1 );
				cds.lpData = (PVOID)p->szFilePath;
				SendMessage( hWndFrom, WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&cds );
			}
			break;
		case XS_IPC_CMD_SHOW_TOOLBAR:	/*	c[o[\/Ȃ	*/
			p->bShowToolbar = (BOOL)nParam;
			ShowWindow( p->hWndToolBar, p->bShowToolbar?SW_SHOW:SW_HIDE );
			InvalidateRect( hWnd, NULL, TRUE );
			RecalcLayout( hWnd );
			break;
		case XS_IPC_CMD_SHOW_NEWLINE:	/*	s}[N\/Ȃ	*/
			p->bShowNewLine = (BOOL)nParam;
			SetOptionMyEdit( p->hWndMyEdit, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
			SetOptionMyList( p->hWndListBoxLow, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
			SetOptionMyList( p->hWndListBoxHi, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
			SetOptionMyScintilla( p->hWndMySci, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment, p->bShowEdge, p->nEdgeColumn );
			RecalcLayout( hWnd );
			InvalidateRect( p->hWndMyEdit, NULL, TRUE );
			InvalidateRect( p->hWndListBoxLow, NULL, TRUE );
			InvalidateRect( p->hWndListBoxHi, NULL, TRUE );
			InvalidateRect( p->hWndMySci, NULL, TRUE );
			break;
		case XS_IPC_CMD_SHOW_LINENUM:	/*	sԍ\/Ȃ	*/
			p->bShowLineNum = (BOOL)nParam;
			SetOptionMyList( p->hWndListBoxLow, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
			SetOptionMyList( p->hWndListBoxHi, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
			SetOptionMyScintilla( p->hWndMySci, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment, p->bShowEdge, p->nEdgeColumn );
			RecalcLayout( hWnd );
			InvalidateRect( p->hWndListBoxLow, NULL, TRUE );
			InvalidateRect( p->hWndListBoxHi, NULL, TRUE );
			InvalidateRect( p->hWndMySci, NULL, TRUE );
			break;
		case XS_IPC_CMD_SHOW_SCROLLBAR:	/*	XN[o[\/Ȃ	*/
			p->bShowScrollBar = (BOOL)nParam;
			if( !p->bEditMode ) {
				ShowWindow( p->hWndScrollBar, p->bShowScrollBar?SW_SHOW:SW_HIDE );
				InvalidateRect( hWnd, NULL, TRUE );
				RecalcLayout( hWnd );
			}
			break;
		case XS_IPC_CMD_SHOW_STATUSBAR:	/*	Xe[^Xo[\/Ȃ	*/
			p->bShowStatusBar = (BOOL)nParam;
			ShowWindow( p->hWndStatusBar, p->bShowStatusBar?SW_SHOW:SW_HIDE );
			InvalidateRect( hWnd, NULL, TRUE );
			RecalcLayout( hWnd );
			break;
		case XS_IPC_CMD_FONT:	/*	tHgύX	*/
			if( nParam == XS_IPC_PARAM_FONT_NOTIFY ) {
				if( hWndFrom != hWnd ) {
					/*	uύXvƂʒm̂ŁALOGFONT\̂₢킹	*/
					PostMessage( hWndFrom, p->uXsIpcMessage, (WPARAM)hWnd, MAKELPARAM( XS_IPC_CMD_FONT, XS_IPC_PARAM_FONT_QUERY ) );
				}
			} else if( nParam == XS_IPC_PARAM_FONT_QUERY ) {
				/*	LOGFONT\̖̂₢킹ɉ	*/
				COPYDATASTRUCT	cds;
				ZeroMemory( &cds, sizeof(cds) );
				cds.dwData = (DWORD)MAKELONG( p->uXsIpcMessage, XS_IPC_CMD_FONT );
				cds.cbData = sizeof(LOGFONT);
				cds.lpData = (PVOID)&(p->lfText);
				SendMessage( hWndFrom, WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&cds );
			}
			break;
		case XS_IPC_CMD_DIAMOND_CURSOR:	/*	_CAhJ[\	*/
			p->bDiamondCursor = (BOOL)nParam;
			SetOptionMyEdit( p->hWndMyEdit, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
			SetOptionMyScintilla( p->hWndMySci, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment, p->bShowEdge, p->nEdgeColumn );
			break;
		case XS_IPC_CMD_CTRL_XC:	/*	Ctrl+X/CJ[\ړ	*/
			p->bCtrlXCCursor = (BOOL)nParam;
			SetOptionMyEdit( p->hWndMyEdit, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
			SetOptionMyScintilla( p->hWndMySci, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment, p->bShowEdge, p->nEdgeColumn );
			break;
		case XS_IPC_CMD_CARET_RIGHT:	/*	Lbg͉E[	*/
			p->bCaretRight = (BOOL)nParam;
			/*	̒ʒm󂯂鑤́A{[ĥ͂łB	*/
			/*	ƂƂ́A̐ݒɊւ炸ALbg͍[̂͂Ȃ̂ŁA	*/
			/*	ȂɂȂB	*/
			break;
		case XS_IPC_CMD_BITMAP_ON_TOOLBAR:	/*	c[o[̃ACR\	*/
			p->bBitmapOnToolbar = (BOOL)nParam;
			DestroyToolBar( p->hWndToolBar );
			{
				ToolBarCreateInfo	tbci;
				tbci.bShow = p->bShowToolbar;
				tbci.bFunction10 = p->bFunctionKey10;
				tbci.bSystemFont = p->bSystemFont;
				tbci.bNoToolTip = p->bNoTooltip;
				tbci.bMultilineTip = p->bMultilineTip;
				tbci.bBitmap = p->bBitmapOnToolbar;
				tbci.bFlat = p->bFlatToolbar;
				p->hWndToolBar = CreateToolBar( hWnd, ID_TOOLBAR, &tbci );
			}
			InvalidateRect( hWnd, NULL, TRUE );
			RecalcLayout( hWnd );
			SetStateToolBar( p->hWndToolBar, p->szFilePath[0] != _T('\0'), p->bHelpMe, p->bViewMode, p->hWndMySci, p->bEditMode );
			break;
		case XS_IPC_CMD_MARK_AS_COMMENT	:	/*	}[NsRg	*/
			p->bMarkAsComment = (BOOL)nParam;
			SetOptionMyEdit( p->hWndMyEdit, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
			SetOptionMyList( p->hWndListBoxLow, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
			SetOptionMyList( p->hWndListBoxHi, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment );
			SetOptionMyScintilla( p->hWndMySci, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment, p->bShowEdge, p->nEdgeColumn );
			InvalidateRect( p->hWndMyEdit, NULL, TRUE );
			InvalidateRect( p->hWndListBoxLow, NULL, TRUE );
			InvalidateRect( p->hWndListBoxHi, NULL, TRUE );
			InvalidateRect( p->hWndMySci, NULL, TRUE );
			break;
		case XS_IPC_CMD_SHOW_EDGE:		/*	̕\	*/
			p->bShowEdge = (BOOL)nParam;
			SetOptionMyScintilla( p->hWndMySci, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment, p->bShowEdge, p->nEdgeColumn );
			InvalidateRect( p->hWndMySci, NULL, TRUE );
			ShowCaption( hWnd );
			break;
		case XS_IPC_CMD_EDGE_COLUMN:	/*	̕	*/
			p->nEdgeColumn = (int)nParam;
			SetOptionMyScintilla( p->hWndMySci, p->bDiamondCursor, p->bCtrlXCCursor, p->bShowLineNum, p->bShowNewLine, p->cNewLine, p->bMarkAsComment, p->bShowEdge, p->nEdgeColumn );
			InvalidateRect( p->hWndMySci, NULL, TRUE );
			ShowCaption( hWnd );
			break;
		default:
			break;
		}
	}
	return( ret );
}
