/*--------------------------------------------------------------*\
		module	:	MarkDlg.c
		purpose :	X-Send }[Nꗗ_CAO
		author	:	_@ Kengo Jinno
		create	:	2001/10/09
		update	:	2001/10/10
					2001/11/13	CreateMyToolTip()̈ǉɑΉ
					2002/03/06	u}[NsRgvł]
								\Ȃ
					2002/03/25	ScintillaΉ
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"MarkDlg.h"
#include	"resource.h"
#include	"ToolTip.h"
#include	"MyList.h"
#include	"Tools.h"
#include	"Hook.h"
#include	"MySci.h"

/*	WM_INITDIALOG	*/
static	void	NEAR	InitDialogProc( HWND hDlg, LpMarkDlgInfo p )
{
	HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hDlg, GWL_HINSTANCE );
	RECT	rect, rectClient;
	
	/*	c[`bv	*/
	if( p->bNoTooltip ) {
		p->hWndToolTip = NULL;
	} else {
		ToolTipDataType	ti[] = {
			{ IDC_LIST_MARK,	IDS_TIPS_LIST_MARK   },
			{ IDOK,             IDS_TIPS_LIST_OK     },
			{ IDCANCEL,         IDS_TIPS_LIST_CANCEL },
		};
		const	int		nCnt = sizeof(ti) / sizeof(ToolTipDataType);
		p->hWndToolTip = CreateMyToolTip( hDlg, ti, nCnt, p->bMultilineTip, TRUE );
	}
	
	/*	TCY{bNX	*/
	p->hWndSizeBox = CreateWindow( _T("SCROLLBAR"), NULL,
		WS_CHILD|WS_VISIBLE|SBS_SIZEBOX|SBS_SIZEBOXBOTTOMRIGHTALIGN|SBS_SIZEGRIP,
		0, 0, 0, 0, hDlg, (HMENU)IDC_SIZE_BOX, hInstance, NULL );
	
	/*	Xg{bNXTuNX	*/
	p->hWndListBox = GetDlgItem( hDlg, IDC_LIST_MARK );
	SubclassMyList( p->hWndListBox, p->bViewMode );
	SetCanHaveFocusMyList( p->hWndListBox, TRUE );
	SetOptionMyList( p->hWndListBox, p->bShowLineNum, p->bShowNewLine, p->cNewLine, FALSE );
	SetFontMyList( p->hWndListBox, p->hFont, p->hFontNewLine );
	MakeLineNumFormatMyList( p->hWndListBox, p->nLineCnt );
	
	if( p->hWndSorcListBox != NULL && IsWindow( p->hWndSorcListBox ) ) {
		/*	Xg{bNXɃ}[NꗗÄʒuI	*/
		InsertMarkMyList( p->hWndListBox, p->hWndSorcListBox, p->nCurrentLine );
	} else if( p->hWndSorcScintilla != NULL && IsWindow( p->hWndSorcScintilla ) ) {
		/*	Xg{bNXɃ}[NꗗÄʒuI	*/
		InsertMarkMyScintilla( p->hWndListBox, p->hWndSorcScintilla, p->nCurrentLine );
	}
	
	/*	TCY	*/
	GetWindowRect( hDlg, &(p->rectInit) );
	
	GetClientRect( hDlg, &rectClient );
	GetWindowRect( p->hWndListBox, &rect );
	ScreenToClientRect( hDlg, &rect );
	p->nMarginRight = rectClient.right - rect.right;
	p->nMarginBottom = rectClient.bottom - rect.bottom;
	GetWindowRect( GetDlgItem( hDlg, IDOK ), &rect );
	ScreenToClientRect( hDlg, &rect );
	p->nMarginButton = rectClient.bottom - rect.bottom;
	
	PostMessage( hDlg, WM_SIZE, 0, 0 );
	
	/*	OƂ̑傫ɂ	*/
	if( p->sizeMarkList.cx > p->rectInit.right - p->rectInit.left ||
		p->sizeMarkList.cy > p->rectInit.bottom - p->rectInit.top ) {
		rect = p->rectInit;
		rect.right = rect.left + p->sizeMarkList.cx;
		rect.bottom = rect.top + p->sizeMarkList.cy;
		MyMoveWindow( hDlg, &rect, TRUE );
	} else if( p->sizeMarkList.cx == 0 || p->sizeMarkList.cy == 0 ) {
		/*	1.5{ɂ	*/
		rect = p->rectInit;
		rect.right = rect.left + 3 * ( rect.right - rect.left ) / 2;
//		rect.bottom = rect.top + 3 * ( rect.bottom - rect.top ) / 2;
		MyMoveWindow( hDlg, &rect, TRUE );
	}
	/*	ēxZ^O	*/
	SendMessage( hDlg, WM_CENTER_PARENT, 0, 0 );	//	CALLWNDtbNȂ̂ŁA|XgĂȂ
}

/*	WM_SIZE	*/
static	void	NEAR	SizeProc( HWND hDlg )
{
	LpMarkDlgInfo	p = (LpMarkDlgInfo)GetWindowLong( hDlg, DWL_USER );
	
	if( p != NULL && !IsIconic( hDlg ) ) {
		RECT	rectWindow;
		RECT	rectClient;
		HWND	hWnd;
		int		nDiff;
		
		GetClientRect( hDlg, &rectClient );
		
		/*	TCY{bNX	*/
		if( p->hWndSizeBox != NULL && IsWindow( p->hWndSizeBox ) ) {
			RECT	rect;
			int		cx, cy;
			GetWindowRect( p->hWndSizeBox, &rect );
			cx = rect.right - rect.left;
			cy = rect.bottom - rect.top;
			rect.right = rectClient.right;
			rect.left = rect.right - cx;
			rect.bottom = rectClient.bottom;
			rect.top = rect.bottom - cy;
			MyMoveWindow( p->hWndSizeBox, &rect, TRUE );
		}
		
		/*	Xg{bNX	*/
		hWnd = GetDlgItem( hDlg, IDC_LIST_MARK );
		GetWindowRect( hWnd, &rectWindow );
		ScreenToClientRect( hDlg, &rectWindow );
		nDiff = rectClient.right - rectWindow.right - p->nMarginRight;
		rectWindow.right += nDiff;
		nDiff = rectClient.bottom - rectWindow.bottom - p->nMarginBottom;
		rectWindow.bottom += nDiff;
		MyMoveWindow( hWnd, &rectWindow, TRUE );
		
		/*	{^	*/
		hWnd = GetDlgItem( hDlg, IDOK );
		GetWindowRect( hWnd, &rectWindow );
		ScreenToClientRect( hDlg, &rectWindow );
		nDiff = rectClient.bottom - rectWindow.bottom - p->nMarginButton;
		rectWindow.top += nDiff;
		rectWindow.bottom += nDiff;
		MyMoveWindow( hWnd, &rectWindow, TRUE );
		
		hWnd = GetDlgItem( hDlg, IDCANCEL );
		GetWindowRect( hWnd, &rectWindow );
		ScreenToClientRect( hDlg, &rectWindow );
		rectWindow.top += nDiff;
		rectWindow.bottom += nDiff;
		MyMoveWindow( hWnd, &rectWindow, TRUE );
	}
}

/*	WM_GETMINMAXINFO	*/
static	void	NEAR	GetMinMaxInfoProc( HWND hDlg, LPMINMAXINFO lpmmi )
{
	LpMarkDlgInfo	p = (LpMarkDlgInfo)GetWindowLong( hDlg, DWL_USER );
	
	if( p != NULL ) {
		lpmmi->ptMinTrackSize.x = p->rectInit.right - p->rectInit.left;
		lpmmi->ptMinTrackSize.y = p->rectInit.bottom - p->rectInit.top;
	}
}


BOOL	MYEXPORT	CALLBACK	MarkDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( uMsg == WM_INITDIALOG ) {
		LpMarkDlgInfo	p = (LpMarkDlgInfo)lParam;
		SetWindowLong( hDlg, DWL_USER, (long)p );
		InitDialogProc( hDlg, p );
		return TRUE;
	} else if( uMsg == WM_SIZE ) {
		SizeProc( hDlg );
	} else if( uMsg == WM_GETMINMAXINFO ) {
		GetMinMaxInfoProc( hDlg, (LPMINMAXINFO)lParam );
	} else if( uMsg == WM_CTLCOLORLISTBOX ) {
		LpMarkDlgInfo	p = (LpMarkDlgInfo)GetWindowLong( hDlg, DWL_USER );
		if( p != NULL && lParam != 0 ) {
			HWND	hWndListBox = (HWND)lParam;
			HBRUSH	hBrush = NULL;
			if( hWndListBox == p->hWndListBox ) {
				hBrush = (HBRUSH)SendMessage( hWndListBox, WM_LIST_CTLCOLOR, wParam, lParam );
			}
			if( hBrush != NULL ) {
				return( (LRESULT)hBrush );
			}
		}
	} else if( uMsg == WM_DRAWITEM ) {
		LpMarkDlgInfo	p = (LpMarkDlgInfo)GetWindowLong( hDlg, DWL_USER );
		if( p != NULL && lParam != 0 ) {
			LPDRAWITEMSTRUCT	lpdis = (LPDRAWITEMSTRUCT)lParam;
			if( lpdis->CtlType == ODT_LISTBOX ) {
				DrawListBoxItem( lpdis->hwndItem, lpdis );
				return TRUE;
			}
		}
	} else if( uMsg == WM_COMMAND ) {
		LpMarkDlgInfo	p = (LpMarkDlgInfo)GetWindowLong( hDlg, DWL_USER );
		WORD	wNotifyCode, wID;
		HWND	hWndCtrl;
#ifdef	WIN32
		wNotifyCode = HIWORD(wParam);
		wID = LOWORD(wParam);
		hWndCtrl = (HWND)lParam;
#else
		wNotifyCode = HIWORD(lParam);
		wID = wParam;
		hWndCtrl = (HWND)LOWORD(lParam);
#endif
		if( wNotifyCode == BN_CLICKED ) {
			if( wID == IDOK ) {
				int		nLineNum = GetLineNumMyList( p->hWndListBox, LB_ERR );
				if( nLineNum >= 0 ) {
					p->nCurrentLine = nLineNum;
				}
				EndDialog( hDlg, IDOK );
			} else if( wID == IDCANCEL ) {
				EndDialog( hDlg, IDCANCEL );
			}
		}
	} else if( uMsg == WM_LIST_SELECT ) {
		LpMarkDlgInfo	p = (LpMarkDlgInfo)GetWindowLong( hDlg, DWL_USER );
		int		nLineNum = GetLineNumMyList( p->hWndListBox, (int)wParam );
		if( nLineNum >= 0 ) {
			p->nCurrentLine = nLineNum;
			EndDialog( hDlg, IDOK );
		}
	} else if( uMsg == WM_NOTIFY ) {
		LpMarkDlgInfo	p = (LpMarkDlgInfo)GetWindowLong( hDlg, DWL_USER );
		LPNMHDR	pnmh = (LPNMHDR)lParam;
		if( pnmh->code == TTN_NEEDTEXT && !p->bNoTooltip ) {
			LPTOOLTIPTEXT	lptip = (LPTOOLTIPTEXT)pnmh;
			if( pnmh->hwndFrom == p->hWndToolTip ) {
				HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hDlg, GWL_HINSTANCE );
				NeedTextMyToolTip( p->hWndToolTip, hInstance, lptip );
			}
		}
	} else if( uMsg == WM_DESTROY ) {
		LpMarkDlgInfo	p = (LpMarkDlgInfo)GetWindowLong( hDlg, DWL_USER );
		RECT	rect;
		GetWindowRect( hDlg, &rect );
		p->sizeMarkList.cx = rect.right - rect.left;
		p->sizeMarkList.cy = rect.bottom - rect.top;
		if( p->hWndToolTip != NULL ) {
			DestroyMyToolTip( p->hWndToolTip );
			p->hWndToolTip = NULL;
		}
		DestroyWindow( p->hWndSizeBox );
		DestroyMyList( p->hWndListBox );
	}
	return FALSE;
}
