/*--------------------------------------------------------------*\
		module	:	MyDDE.c
		purpose :	X-Send DDENCAg
		author	:	_@ Kengo Jinno
		create	:	2001/09/19
		update	:	2001/09/26
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"MyDDE.h"
#include	"Tools.h"

/*	WM_DDE_ACK	*/
BOOL	DdeAckProc( HWND hWnd, NpMyDdeInfoType pInfo, WPARAM wParam, LPARAM lParam )
{
	BOOL	ret = FALSE;
	if( pInfo == NULL ) {
		/*	Ȃ	*/
	} else if( pInfo->nClientStatus == DDE_STAT_INITIATE ) {	//	WM_DDE_INITIATE
		pInfo->hWndServer = (HWND)wParam;
		pInfo->nClientStatus = DDE_STAT_IDLE;
		ret = TRUE;
	} else if( pInfo->nClientStatus == DDE_STAT_EXECUTE ) {		//	WM_DDE_EXECUTE
		HWND	hWndServer = (HWND)wParam;
		HGLOBAL	hCmd;
#ifdef	WIN32
		UINT	uLow;
		UnpackDDElParam( WM_DDE_ACK, lParam, &uLow, (UINT*)&hCmd );
#else
		hCmd = (HGLOBAL)HIWORD( lParam );
#endif
		GlobalFree( hCmd );
#ifdef	WIN32
		FreeDDElParam( WM_DDE_ACK, lParam );
#endif
		pInfo->nClientStatus = DDE_STAT_IDLE;
		ret = TRUE;
	}
	
	return ret;
}

/*	WM_DDE_TERMINATE	*/
BOOL	DdeTerminateProc( HWND hWnd, NpMyDdeInfoType pInfo, WPARAM wParam, LPARAM lParam )
{
	BOOL	ret = FALSE;
	switch( pInfo->nClientStatus ) {
	case DDE_STAT_IDLE:				/*	T[o[TerminateĂ	*/
		PostMessage( (HWND)wParam, WM_DDE_TERMINATE, (WPARAM)hWnd, 0 );
		/*	̂܂ܗ	*/
	case DDE_STAT_TERMINATE:		/*	TerminatevɃT[o[Ԏ	*/
		pInfo->nClientStatus = DDE_STAT_NONE;
		pInfo->hWndServer = NULL;
		ret = TRUE;
		break;
	}
	return ret;
}


static	BOOL	InitiatePrimitiveDDE( HWND hWnd, NpMyDdeInfoType pInfo, HWND hWndTo )
{
	if( pInfo != NULL && pInfo->nClientStatus == DDE_STAT_NONE ) {
		ATOM	aApp, aTopic;
		LPARAM	lParam;
		DWORD	dwResult;
		static	const	TCHAR	BASED_CODE	szTopicName[] = _T("Command");
		
		aApp = GlobalAddAtom( pInfo->lpszServiceName );
		aTopic = GlobalAddAtom( szTopicName );
		lParam = MAKELPARAM( aApp, aTopic );
		pInfo->nClientStatus = DDE_STAT_INITIATE;
		if( hWndTo == NULL || !IsWindow( hWndTo ) ) {
			hWndTo = HWND_BROADCAST;
		}
		SendMessageTimeout( hWndTo, WM_DDE_INITIATE, (WPARAM)hWnd, lParam, SMTO_ABORTIFHUNG, 300, &dwResult );
//		SendMessage( hWndTo, WM_DDE_INITIATE, (WPARAM)hWnd, lParam );
		GlobalDeleteAtom( aApp );
		GlobalDeleteAtom( aTopic );
		if( pInfo->nClientStatus != DDE_STAT_IDLE ) {
			pInfo->nClientStatus = DDE_STAT_NONE;
		}
	}
	return( pInfo->nClientStatus == DDE_STAT_IDLE );
}

BOOL	InitiateDDE( HWND hWnd, NpMyDdeInfoType pInfo, HWND hWndLastServer )
{
	HWND	hWndTo;
	BOOL	bExist;
	
	/*	ÕEBhE`W	*/
	if( hWndLastServer != NULL && IsWindow( hWndLastServer ) ) {
		hWndTo = hWndLastServer;
	} else {
		hWndTo = NULL;
	}
	bExist = InitiatePrimitiveDDE( hWnd, pInfo, hWndTo );
	if( !bExist && hWndTo != NULL ) {
		/*	߂A߂ău[hLXg	*/
		bExist = InitiatePrimitiveDDE( hWnd, pInfo, NULL );
	}
	
	return( bExist );
}

BOOL	SendDDEString( HWND hWnd, NpMyDdeInfoType pInfo, LPCTSTR lpszText )
{
	if( pInfo == NULL ) {
		return FALSE;
	}
	if( pInfo->nClientStatus != DDE_STAT_IDLE || pInfo->hWndServer == NULL || !IsWindow( pInfo->hWndServer ) ) {
		return FALSE;
	} else {
		TCHAR	cSep = _T('@');
		static	const	TCHAR	BASED_CODE	lpszFormat[] = _T("[Send(@)]");
		int		nLen = lstrlen( lpszText ) + lstrlen( lpszFormat );
		HGLOBAL	hGlobal = GlobalAlloc( GMEM_MOVEABLE|GMEM_DDESHARE|GMEM_ZEROINIT, (nLen+1)*sizeof(TCHAR) );
		LPTSTR	lpszGlobal = (LPTSTR)GlobalLock( hGlobal );
		LPARAM	lParam;
		
		/*
			wsprintf()1024byte̐̂ŎgȂB
			ǂrɕ𖄂ߍނȂ̂ŁAOłB
		*/
		{
			LPTSTR	p;
			LPCTSTR	q, r;
			p = lpszGlobal;		//	Rs[
			q = lpszFormat;		//	tH[}bg
			r = lpszText;		//	p[^
			while( *q != _T('\0') ) {
				if( *q == cSep ) {
					//	Zp[^Ƀp[^̕}
					while( *r != _T('\0') ) {
						*(p++) = *(r++);
					}
					q++;
				} else {
					*(p++) = *(q++);
				}
			}
			*p = _T('\0');
		}
		GlobalUnlock( hGlobal );
#ifdef	WIN32
		lParam = PackDDElParam( WM_DDE_EXECUTE, 0, (UINT)hGlobal );
#else
		lParam = MAKELPARAM( 0, hGlobal );
#endif
		pInfo->nClientStatus = DDE_STAT_EXECUTE;
		if( !PostMessage( pInfo->hWndServer, WM_DDE_EXECUTE, (WPARAM)hWnd, lParam ) ) {
			pInfo->nClientStatus = DDE_STAT_IDLE;
			GlobalFree( hGlobal );
#ifdef	WIN32
			FreeDDElParam( WM_DDE_EXECUTE, lParam );
#endif
		} else {
			MSG	msg;
			DWORD	dwTick = GetTickCount();
			while( pInfo->nClientStatus == DDE_STAT_EXECUTE ) {
				if( !GetMessage( &msg, NULL, 0, 0 ) ) {
					PostQuitMessage( msg.wParam );
					break;
				} else {
					(pInfo->lpfnMessagePump)( hWnd, &msg );
				}
				if( GetTickDiff( GetTickCount(), dwTick ) > 10000 ) {
					pInfo->nClientStatus = DDE_STAT_IDLE;
					break;
				}
			}
		}
	}
	
	return TRUE;
}

BOOL	TerminateDDE( HWND hWnd, NpMyDdeInfoType pInfo )
{
	if( pInfo != NULL && pInfo->nClientStatus == DDE_STAT_IDLE ) {
		pInfo->nClientStatus = DDE_STAT_TERMINATE;
		if( PostMessage( pInfo->hWndServer, WM_DDE_TERMINATE, (WPARAM)hWnd, 0 ) ) {
			MSG	msg;
			DWORD	dwTick = GetTickCount();
			while( pInfo->nClientStatus == DDE_STAT_TERMINATE ) {
				if( !GetMessage( &msg, NULL, 0, 0 ) ) {
					PostQuitMessage( msg.wParam );
					break;
				} else {
					(pInfo->lpfnMessagePump)( hWnd, &msg );
				}
				if( GetTickDiff( GetTickCount(), dwTick ) > 10000 ) {
					pInfo->nClientStatus = DDE_STAT_NONE;
					break;
				}
			}
		}
	}
	
	return TRUE;
}

/*	T[o[̑݃`FbN	*/
BOOL	CheckDDEServer( HWND hWnd, NpMyDdeInfoType pInfo, LPCTSTR lpszServer )
{
	BOOL	bExist = FALSE;
	
	if( pInfo != NULL && lpszServer != NULL && lpszServer[0] != _T('\0') ) {
		LPCTSTR	lpszBuff = pInfo->lpszServiceName;
		
		pInfo->lpszServiceName = lpszServer;
		TerminateDDE( hWnd, pInfo );	/*	`FbN⑗oŐڑςȂȂ̂	*/
		if( InitiatePrimitiveDDE( hWnd, pInfo, NULL ) ) {
			bExist = TRUE;
			TerminateDDE( hWnd, pInfo );
		}
		
		pInfo->lpszServiceName = lpszBuff;
	}
	
	return bExist;
}

/*	T[o[T	*/
LPCTSTR	SearchDDEServer( HWND hWnd, NpMyDdeInfoType pInfo, LPCTSTR* pArray, int nCnt )
{
	int		i;
	LPCTSTR	p;
	
	for( i = 0; i < nCnt; i++ ) {
		p = pArray[i];
		if( p != NULL ) {
			if( CheckDDEServer( hWnd, pInfo, p ) ) {
				return p;
			}
		}
	}
	
	return NULL;
}
