/*--------------------------------------------------------------*\
		module	:	MyEdit.c
		purpose :	X-Send ҏWs
		author	:	_@ Kengo Jinno
		create	:	2001/09/04
		update	:	2001/10/10
					2001/11/01	IsBadReadPtr() IsBadCodePtr()
								ĝ߂B(Win2K/XP)
					2001/11/13	GetRectMyEdit()ǉ
					2001/11/13	s}[N̕`ʒúAEM_POSFROMCHAR
								̖߂lshortɃLXg
					2001/11/21	MyEditDataType::bIsCommentǉ
					2001/11/21	SetTextMyEdit()ɈbCommentǉ
					2002/03/06	MyEditDataType::bIsMarkǉ
					2002/03/06	MyEditDataType::bMarkAsCommentǉ
					2002/03/06	SetTextMyEdit()ɈbMarkǉ
					2002/03/06	SetOptionMyEdit()ɈbMarkAsCommentǉ
					2004/02/23	mۃ`FbNd
					2011/02/17	EM_REPLACESELłs}[Nĕ`悷
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"MyEdit.h"
#include	"resource.h"


static	LPCTSTR		lpszPropertyName = _T("09a442c0-a13b-11d5-af4f-00c0ca10a705");


/*	ҏWs̍쐬	*/
HWND	CreateMyEdit( HWND hWndParent, UINT nCtrlID, BOOL bViewMode )
{
	HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hWndParent, GWL_HINSTANCE );
	DWORD	dwStyle;
	HWND	hWnd;
	
	/*	EBhE쐬	*/
	dwStyle = ES_AUTOHSCROLL|ES_NOHIDESEL;
	if( bViewMode ) {
		dwStyle |= ES_READONLY;
	}
	hWnd = CreateWindowEx( WS_EX_CLIENTEDGE, _T("EDIT"), NULL,
		WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|dwStyle,
		0, 0, 0, 0, hWndParent, (HMENU)nCtrlID, hInstance, NULL );
	
	if( hWnd != NULL ) {
		LpMyEditDataType	p;
		p = (LpMyEditDataType)GlobalAlloc( GPTR, sizeof(MyEditDataType) );
		if( p == NULL ) {
			DestroyWindow( hWnd );
			return( NULL );
		}
		ZeroMemory( p, sizeof(MyEditDataType) );
		p->bEnableDiamond = TRUE;
		p->bEnableCtrlXC = TRUE;
		p->hAccel = LoadAccelerators( hInstance, MAKEINTRESOURCE( IDR_ACCEL_EDIT ) );
		p->hAccelDiamond = LoadAccelerators( hInstance, MAKEINTRESOURCE( IDR_ACCEL_DIAMOND ) );
		p->hAccelCtrlXC = LoadAccelerators( hInstance, MAKEINTRESOURCE( IDR_ACCEL_DIAMOND2 ) );
		p->hFontNewLine = NULL;
		p->bShowNewLine = TRUE;
		p->cNewLine = _T('\0');
		p->bHelpMe = FALSE;
		p->bViewMode = bViewMode;
		p->bIsComment = FALSE;
		p->bIsMark = FALSE;
		p->bMarkAsComment = FALSE;
		p->hTextBuff = NULL;
		p->dwTextbuffSize = 0;
		/*	vpeBɃZbg	*/
		SetProp( hWnd, lpszPropertyName, (HANDLE)p );
		/*	TuNX	*/
		p->lpfnOldWndProc = (WNDPROC)SetWindowLong( hWnd, GWL_WNDPROC, (LONG)MyEditWndProc );
	}
	
	return( hWnd );
}

/*	ҏWs̔j	*/
BOOL	DestroyMyEdit( HWND hWnd )
{
	BOOL	ret = TRUE;
	if( IsWindow( hWnd ) ) {
		LpMyEditDataType	p = (LpMyEditDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			/*	TuNX	*/
			if( p->lpfnOldWndProc != NULL ) {
				SetWindowLong( hWnd, GWL_WNDPROC, (LONG)p->lpfnOldWndProc );
				p->lpfnOldWndProc = NULL;
			}
			/*		*/
			if( p->hTextBuff != NULL ) {
				GlobalFree( (HGLOBAL)p->hTextBuff );
				p->hTextBuff = NULL;
			}
			p->dwTextbuffSize = 0;
			/*	vpeB폜	*/
			RemoveProp( hWnd, lpszPropertyName );
			GlobalFree( (HGLOBAL)p );
		}
		/*	p	*/
		ret = DestroyWindow( hWnd );
	}
	return ret;
}

/*	TuNXvV[W	*/
LRESULT	MYEXPORT	CALLBACK	MyEditWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	LpMyEditDataType	p = (LpMyEditDataType)GetProp( hWnd, lpszPropertyName );
	if( p == NULL || p->lpfnOldWndProc == NULL ) {
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}
	if( uMsg == WM_KEYDOWN || uMsg == WM_CHAR || uMsg == WM_PASTE || uMsg == WM_CUT || uMsg == WM_CLEAR || uMsg == EM_SETSEL || uMsg == EM_REPLACESEL ) {
		LRESULT	ret = CallWindowProc( p->lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
		/*	s}[Nĕ`悳	*/
		SendMessage( hWnd, WM_PAINT, 0, 0 );
		return ret;
	} else if( uMsg == WM_EDIT_CTLCOLOR_EDIT ) {
		/*	wiuVԂ	*/
		if( wParam != 0 && lParam != 0 ) {
			HDC		hDC = (HDC)wParam;
			HWND	hWndEdit = (HWND)lParam;
			HBRUSH	hBrush = NULL;
			if( hWndEdit == hWnd ) {
				if( p->bViewMode ) {
					if( p->bHelpMe ) {
						hBrush = GetSysColorBrush( COLOR_HIGHLIGHT );
						SetBkColor( hDC, GetSysColor( COLOR_HIGHLIGHT ) );
						SetTextColor( hDC, GetSysColor( COLOR_HIGHLIGHTTEXT ) );
					} else {
						hBrush = GetSysColorBrush( COLOR_BTNFACE );
						SetBkColor( hDC, GetSysColor( COLOR_BTNFACE ) );
						SetTextColor( hDC, GetSysColor( COLOR_BTNTEXT ) );
					}
				} else {
					if( p->bHelpMe ) {
						hBrush = GetSysColorBrush( COLOR_BTNFACE );
						SetBkColor( hDC, GetSysColor( COLOR_BTNFACE ) );
						SetTextColor( hDC, GetSysColor( COLOR_BTNTEXT ) );
					} else {
						hBrush = GetSysColorBrush( COLOR_WINDOW );
						SetBkColor( hDC, GetSysColor( COLOR_WINDOW ) );
						SetTextColor( hDC, GetSysColor( COLOR_WINDOWTEXT ) );
					}
				}
				/*	RgȂ甽]\(2001/11/21)	*/
				/*	u}[NsRgṽ}[Nsł]\(2002/03/06)	*/
				if( p->bIsComment || ( p->bIsMark && p->bMarkAsComment ) ) {
					hBrush = GetSysColorBrush( COLOR_HIGHLIGHT );
					SetBkColor( hDC, GetSysColor( COLOR_HIGHLIGHT ) );
					SetTextColor( hDC, GetSysColor( COLOR_HIGHLIGHTTEXT ) );
				}
			}
			return( (LRESULT)hBrush );
		}
	} else if( uMsg == WM_PAINT && p->hFontNewLine != NULL && p->bShowNewLine ) {
		/*	sɉs}[N`	*/
		LRESULT	ret = CallWindowProc( p->lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
		BOOL	bFocused;
		HDC		hDC;
		HFONT	hFont;
		HFONT	hOldFont;
		int		nLen;
		RECT	rect;
		BOOL	bReadOnly;
		COLORREF	colText;
		COLORREF	colBack;
		COLORREF	colOldText;
		COLORREF	colOldBack;
		
		bFocused = ( GetFocus() == hWnd );
		if( bFocused ) {
			/*	GetDC()`ReleaseDC()̊OōsȂ˂΂ȂȂ	*/
			HideCaret( hWnd );
		}
		
		hDC = GetDC( hWnd );
		hFont = (HFONT)SendMessage( hWnd, WM_GETFONT, 0, 0 );
		hOldFont = (HFONT)SelectObject( hDC, hFont );
		
		/*	܂́A`ׂʒǔvZ	*/
		SendMessage( hWnd, EM_GETRECT, 0, (LPARAM)&rect );
		nLen = GetWindowTextLength( hWnd );
		if( nLen > 0 ) {
			DWORD	dwPos;
			LPTSTR	pData;
			/*	XN[Ăꍇ̊Jnʒu	*/
			dwPos = SendMessage( hWnd, EM_POSFROMCHAR, 0, 0 );
			rect.left = (short)LOWORD( dwPos );
			/*	̒Z	*/
			pData = (LPTSTR)GlobalAlloc( GPTR, sizeof(TCHAR)*(nLen+1) );
			if( pData != NULL ) {
				SIZE	size;
				GetWindowText( hWnd, pData, nLen+1 );
				GetTextExtentPoint32( hDC, pData, nLen, &size );
				GlobalFree( (HGLOBAL)pData );
				rect.left += size.cx;
			}
		}
		
		colOldText = GetTextColor( hDC );
		colOldBack = GetBkColor( hDC );
		SendMessage( hWnd, WM_EDIT_CTLCOLOR_EDIT, (WPARAM)hDC, (LPARAM)hWnd );
		if( !( ( p->bHelpMe && p->bViewMode ) || p->bIsComment || ( p->bIsMark && p->bMarkAsComment ) ) ) {
			SetTextColor( hDC, GetSysColor( COLOR_HIGHLIGHT ) );
		}
		
		SelectObject( hDC, p->hFontNewLine );
		ExtTextOut( hDC, rect.left, rect.top+1, ETO_CLIPPED|ETO_OPAQUE, &rect, &(p->cNewLine), 1, NULL );
		
		SetTextColor( hDC, colOldText );
		SetBkColor( hDC, colOldBack );
		
		SelectObject( hDC, hOldFont );
		ReleaseDC( hWnd, hDC );
		
		if( bFocused ) {
			ShowCaret( hWnd );
		}
		
		return ret;
	} else if( uMsg == WM_MOUSEWHEEL || uMsg == WM_VSCROLL || ( gnMsgMouseWheel != 0 && uMsg == gnMsgMouseWheel ) ) {
		HWND	hWndParent = GetParent( hWnd );
		if( hWndParent != NULL && IsWindow( hWndParent ) ) {
			return SendMessage( hWndParent, uMsg, wParam, lParam );
		}
	} else if( uMsg == WM_DESTROY ) {
		RemoveProp( hWnd, lpszPropertyName );
	}
//	if( IsBadReadPtr( &(p->lpfnOldWndProc), sizeof(p->lpfnOldWndProc) ) || IsBadCodePtr( (FARPROC)p->lpfnOldWndProc ) ) {
//		return DefWindowProc( hWnd, uMsg, wParam, lParam );
//	}
	return CallWindowProc( p->lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
}

/*	œKȍԂ	*/
int		GetSuitableHeightMyEdit( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		HDC		hDC;
		RECT	rect, rectClient;
		int		nHeight;
		
		SendMessage( hWnd, EM_GETRECT, 0, (LPARAM)&rect );	/*	``	*/
		hDC = GetDC( hWnd );
		if( hDC != NULL ) {
			TEXTMETRIC	tm;
			HFONT	hFont = (HFONT)SendMessage( hWnd, WM_GETFONT, 0, 0 );
			HFONT	hOldFont = (HFONT)SelectObject( hDC, hFont );
			GetTextMetrics( hDC, &tm );
			nHeight = tm.tmHeight + tm.tmExternalLeading;
			nHeight = ( nHeight > rect.bottom-rect.top ) ? nHeight : rect.bottom-rect.top;
			nHeight += 2*rect.left;		/*	̏㉺̋󔒕␳	*/
			/*	(rect.toṕATCYEditBox傫Ƀ[ɂȂ̂ŁAleftg)	*/
			SelectObject( hDC, hOldFont );
			ReleaseDC( hWnd, hDC );
		} else {
			HFONT	hFont = (HFONT)SendMessage( hWnd, WM_GETFONT, 0, 0 );
			LOGFONT	lf;
			GetObject( hFont, sizeof(lf), &lf );
			nHeight = lf.lfHeight;
			nHeight = ( nHeight > 0 ) ? nHeight : -nHeight;
			nHeight = (int)( ( (long)nHeight * 120L ) / 100L );
		}
		
		GetWindowRect( hWnd, &rect );
		GetClientRect( hWnd, &rectClient );
		nHeight += ( rect.bottom - rect.top ) - ( rectClient.bottom - rectClient.top );
		
		return nHeight;
	}
	return 0;
}

/*	tHgݒ	*/
void	SetFontMyEdit( HWND hWnd, HFONT hFont, HFONT hFontNewLine )
{
	if( IsWindow( hWnd ) ) {
		LpMyEditDataType	p = (LpMyEditDataType)GetProp( hWnd, lpszPropertyName );
		
		SendMessage( hWnd, WM_SETFONT, (WPARAM)hFont, MAKELPARAM( TRUE, 0 ) );
		
		/*	s}[NptHg	*/
		if( p != NULL ) {
			p->hFontNewLine = hFontNewLine;
		}
	}
}

/*	IvVݒ	*/
void	SetOptionMyEdit( HWND hWnd, BOOL bDiamond, BOOL bCtrlXC, BOOL bShowNewLine, TCHAR cNewLine, BOOL bMarkAsComment )
{
	if( IsWindow( hWnd ) ) {
		LpMyEditDataType	p = (LpMyEditDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			if( p->bEnableDiamond != bDiamond ) {
				p->bEnableDiamond = bDiamond;
			}
			if( p->bEnableCtrlXC != bCtrlXC ) {
				p->bEnableCtrlXC = bCtrlXC;
			}
			if( p->bShowNewLine != bShowNewLine ) {
				p->bShowNewLine = bShowNewLine;
			}
			if( p->cNewLine != cNewLine ) {
				p->cNewLine = cNewLine;
			}
			if( p->bMarkAsComment != bMarkAsComment ) {
				p->bMarkAsComment = bMarkAsComment;
			}
		}
	}
}

/*	ANZ[^	*/
BOOL	TranslateAcceleratorMyEdit( HWND hWndParent, HWND hWnd, LPMSG pMsg )
{
	LpMyEditDataType	p;
	
	if( !IsWindow( hWnd ) ) {
		return FALSE;
	}
	if( pMsg->hwnd != hWnd ) {
		return FALSE;
	}
	p = (LpMyEditDataType)GetProp( hWnd, lpszPropertyName );
	if( p == NULL ) {
		return FALSE;
	}
	/*	_CAhJ[\̃ANZ[^	*/
	if( p->bEnableDiamond && p->hAccelDiamond != NULL && TranslateAccelerator( hWndParent, p->hAccelDiamond, pMsg ) ) {
		return TRUE;
	}
	if( p->bEnableDiamond && p->bEnableCtrlXC && p->hAccelCtrlXC != NULL && TranslateAccelerator( hWndParent, p->hAccelCtrlXC, pMsg ) ) {
		return TRUE;
	}
	/*	ʏ(Nbv{[h֌W)̃ANZ[^	*/
	if( p->hAccel != NULL && TranslateAccelerator( hWndParent, p->hAccel, pMsg ) ) {
		return TRUE;
	}
	return FALSE;
}

/*	łv	*/
void	SetHelpMeMyEdit( HWND hWnd, BOOL bFlag )
{
	if( IsWindow( hWnd ) ) {
		LpMyEditDataType	p = (LpMyEditDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			if( p->bHelpMe != bFlag ) {
				InvalidateRect( hWnd, NULL, TRUE );
			}
			p->bHelpMe = bFlag;
			SendMessage( hWnd, EM_SETREADONLY, p->bHelpMe||p->bViewMode, 0 );
		}
	}
}

/*	{[h̐ݒ	*/
void	SetViewModeMyEdit( HWND hWnd, BOOL bFlag )
{
	if( IsWindow( hWnd ) ) {
		LpMyEditDataType	p = (LpMyEditDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			if( p->bViewMode != bFlag ) {
				InvalidateRect( hWnd, NULL, TRUE );
			}
			p->bViewMode = bFlag;
			SendMessage( hWnd, EM_SETREADONLY, p->bHelpMe||p->bViewMode, 0 );
		}
	}
}

/*	eLXgZbg	*/
void	SetTextMyEdit( HWND hWnd, LPCTSTR lpszText, BOOL bComment, BOOL bMark )
{
	if( IsWindow( hWnd ) ) {
		LpMyEditDataType	p = (LpMyEditDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			p->bIsComment = bComment;
			p->bIsMark = bMark;
		}
		if( lpszText == NULL ) {
			lpszText = _T("");
		}
		SetWindowText( hWnd, lpszText );
	}
}

/*	eLXg擾	*/
LPCTSTR	GetTextMyEdit( HWND hWnd, BOOL bAll, int* pLen )
{
	LPCTSTR	ret = _T("");
	if( pLen != NULL ) {
		*pLen = 0;
	}
	if( IsWindow( hWnd ) ) {
		LpMyEditDataType	p = (LpMyEditDataType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			int		nLen = GetWindowTextLength( hWnd );
			DWORD	dwSize = sizeof(TCHAR)*(nLen+1);
			LPTSTR	q;
			if( p->dwTextbuffSize < dwSize ) {
				if( p->hTextBuff == NULL ) {
					p->hTextBuff = GlobalAlloc( GPTR, dwSize );
				} else {
					HGLOBAL	h = GlobalReAlloc( p->hTextBuff, dwSize, GMEM_MOVEABLE|GMEM_ZEROINIT );
					if( h == NULL ) {
						GlobalFree( p->hTextBuff );
						dwSize = 0;
					}
					p->hTextBuff = h;
				}
				p->dwTextbuffSize = dwSize;
			}
			q = (LPTSTR)( p->hTextBuff );
			if( q != NULL ) {
				GetWindowText( hWnd, q, nLen+1 );
				if( !bAll ) {
					DWORD	dwSel = SendMessage( hWnd, EM_GETSEL, (WPARAM)NULL, (LPARAM)NULL );
					int		nSt = LOWORD( dwSel );
					int		nEn = HIWORD( dwSel );
					LPTSTR	r;
					if( nSt != nEn ) {
						/*	IĂ͈	*/
						r = q + nSt;
						nLen = nEn - nSt;
					} else {
						/*	Lbg荶	*/
						r = q;
						nLen = nSt;
					}
					*( r + nLen ) = _T('\0');
					ret = r;
					/*	cĐݒ	*/
					SendMessage( hWnd, WM_SETREDRAW, FALSE, 0 );
					if( nSt == nEn ) {
						/*	Lbg荶I	*/
						SendMessage( hWnd, EM_SETSEL, 0, nSt );
					}
					SendMessage( hWnd, WM_CLEAR, 0, 0 );
					SendMessage( hWnd, WM_SETREDRAW, TRUE, 0 );
					InvalidateRect( hWnd, NULL, TRUE );
				} else {
					ret = q;
					SetWindowText( hWnd, _T("") );	/*	ۂɂ	*/
				}
				if( pLen != NULL ) {
					*pLen = nLen;
				}
			}
		}
	}
	return( ret );
}

/*	``擾	*/
void	GetRectMyEdit( HWND hWnd, LPRECT lprect )
{
	if( IsWindow( hWnd ) && lprect != NULL ) {
		SendMessage( hWnd, EM_GETRECT, 0, (LPARAM)lprect );
	}
}




/*	Undoł邩H	*/
extern	BOOL	CanUndoMyEdit( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		return SendMessage( hWnd, EM_CANUNDO, 0, 0 );
	}
	return FALSE;
}

/*	IĂ邩H	*/
extern	BOOL	IsSelectedMyEdit( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		DWORD	dwSel = SendMessage( hWnd, EM_GETSEL, 0, 0 );
		return( LOWORD(dwSel) != HIWORD(dwSel) );
	}
	return FALSE;
}

/*	\tł邩H	*/
extern	BOOL	CanPasteMyEdit( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		return IsClipboardFormatAvailable( CF_TEXT );
	}
	return FALSE;
}

/*	eLXg邩H	*/
extern	BOOL	HasTextMyEdit( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		return( GetWindowTextLength( hWnd ) > 0 );
	}
	return FALSE;
}

/*	Undo	*/
extern	void	DoUndoMyEdit( HWND hWnd )
{
	if( CanUndoMyEdit( hWnd ) ) {
		SendMessage( hWnd, EM_UNDO, 0, 0 );
	}
}

/*	؂	*/
extern	void	DoCutMyEdit( HWND hWnd )
{
	if( IsSelectedMyEdit( hWnd ) ) {
		SendMessage( hWnd, WM_CUT, 0, 0 );
	}
}

/*	Rs[	*/
extern	void	DoCopyMyEdit( HWND hWnd )
{
	if( IsSelectedMyEdit( hWnd ) ) {
		SendMessage( hWnd, WM_COPY, 0, 0 );
	}
}

/*	\t	*/
extern	void	DoPasteMyEdit( HWND hWnd )
{
	if( CanPasteMyEdit( hWnd ) ) {
		SendMessage( hWnd, WM_PASTE, 0, 0 );
	}
}

/*	擪	*/
extern	void	DoTopMyEdit( HWND hWnd )
{
	if( HasTextMyEdit( hWnd ) ) {
		SendMessage( hWnd, EM_SETSEL, 0, 0 );
	}
}

/*	Ō	*/
extern	void	DoLastMyEdit( HWND hWnd )
{
	if( HasTextMyEdit( hWnd ) ) {
		int		nLen = GetWindowTextLength( hWnd );
		SendMessage( hWnd, EM_SETSEL, nLen, nLen );
	}
}

/*	폜	*/
extern	void	DoDelMyEdit( HWND hWnd )
{
	if( HasTextMyEdit( hWnd ) ) {
		DWORD	dwSel = SendMessage( hWnd, EM_GETSEL, 0, 0 );
		int		nSt = LOWORD( dwSel );
		int		nEn = HIWORD( dwSel );
		if( nSt == nEn && !IsReadOnlyMyEdit( hWnd ) ) {
			int		nLen = GetWindowTextLength( hWnd );
			LPTSTR	p = (LPTSTR)GlobalAlloc( GPTR, sizeof(TCHAR)*(nLen+1) );
			if( p != NULL ) {
				LPTSTR	q;
				GetWindowText( hWnd, p, nLen+1 );
				q = CharNext( p+nSt );
				nEn = q-p;
				GlobalFree( (HGLOBAL)p );
				SendMessage( hWnd, EM_SETSEL, nSt, nEn );
			}
		}
		SendMessage( hWnd, WM_CLEAR, 0, 0 );
	}
}

/*	O	*/
extern	void	DoPrevMyEdit( HWND hWnd )
{
	if( HasTextMyEdit( hWnd ) ) {
		DWORD	dwSel = SendMessage( hWnd, EM_GETSEL, 0, 0 );
		int		nSt = LOWORD( dwSel );
		int		nEn = HIWORD( dwSel );
		int		nLen = GetWindowTextLength( hWnd );
		LPTSTR	p = (LPTSTR)GlobalAlloc( GPTR, sizeof(TCHAR)*(nLen+1) );
		if( p != NULL ) {
			LPTSTR	q;
			GetWindowText( hWnd, p, nLen+1 );
			q = CharPrev( p, p+nEn );
			nSt = q-p;
			GlobalFree( (HGLOBAL)p );
			SendMessage( hWnd, EM_SETSEL, nSt, nSt );
		}
	}
}

/*		*/
extern	void	DoNextMyEdit( HWND hWnd )
{
	if( HasTextMyEdit( hWnd ) ) {
		DWORD	dwSel = SendMessage( hWnd, EM_GETSEL, 0, 0 );
		int		nSt = LOWORD( dwSel );
		int		nEn = HIWORD( dwSel );
		int		nLen = GetWindowTextLength( hWnd );
		LPTSTR	p = (LPTSTR)GlobalAlloc( GPTR, sizeof(TCHAR)*(nLen+1) );
		if( p != NULL ) {
			LPTSTR	q;
			GetWindowText( hWnd, p, nLen+1 );
			q = CharNext( p+nSt );
			nSt = q-p;
			GlobalFree( (HGLOBAL)p );
			SendMessage( hWnd, EM_SETSEL, nSt, nSt );
		}
	}
}

/*	Undoobt@NA	*/
extern	void	EmptyUndoBufferMyEdit( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		SendMessage( hWnd, EM_EMPTYUNDOBUFFER, 0, 0 );
	}
}

/*	[hI[H	*/
BOOL	IsReadOnlyMyEdit( HWND hWnd )
{
	BOOL	ret = FALSE;
	if( IsWindow( hWnd ) ) {
		ret = ( ( GetWindowLong( hWnd, GWL_STYLE ) & ES_READONLY ) != 0 );
	}
	return( ret );
}

/*	[hI[̐ݒ	*/
void	SetReadOnlyMyEdit( HWND hWnd, BOOL f )
{
	if( IsWindow( hWnd ) ) {
		SendMessage( hWnd, EM_SETREADONLY, f, 0 );
	}
}
