/*--------------------------------------------------------------*\
		module	:	MySci.h
		purpose :	X-Send Scintilla
		author	:	_@ Kengo Jinno
		create	:	2002/03/19
		update	:	2002/04/17
\*--------------------------------------------------------------*/

#ifndef	MYSCI_H
#define	MYSCI_H

#include	"..\Scintilla\Scintilla.h"
#include	"MarkCmnt.h"

typedef	void*	LP_DATA_SCI_DIRECT;
typedef	int (*LP_FUNC_SCI_DIRECT)(LP_DATA_SCI_DIRECT,int,WPARAM,LPARAM);

typedef	struct	tagMySciDataType	{
	WNDPROC		lpfnOldWndProc;
	
	BOOL		bEnableDiamond;		/*	_CAhJ[\g	*/
	BOOL		bEnableCtrlXC;		/*	Ctrl+X/CJ[\ړ	*/
	
	HACCEL		hAccelSci;
	HACCEL		hAccelDiamond;		/*	_CAhJ[\̃ANZ[^	*/
	
	BOOL		bShowLineNum;		/*	sԍ\		*/
	BOOL		bShowNewLine;		/*	s}[N\TRUE	*/
	BOOL		bShowEdge;			/*	\			*/
	int			nEdgeColumn;		/*					*/
	BOOL		bMarkAsComment;		/*	}[NsRg	*/
	
	int			nLineNumWidth;		/*	sԍ̕	*/
	
	COLORREF	colNormal;			/*	ʏ̔wiF	*/
	COLORREF	colReverse;			/*	]̔wiF	*/
	
	HGLOBAL		hTextBuff;			/*	擾pobt@	*/
	DWORD		dwTextBuffSize;		/*	obt@̃TCY		*/
	
	HGLOBAL		hSaveBuff;			/*	Z[uẽobt@	*/
	DWORD		dwSaveBuffSize;		/*	obt@̃TCY	*/
	
	LP_FUNC_SCI_DIRECT	fn;
	LP_DATA_SCI_DIRECT	pt;
	
}	MySciDataType, FAR* LpMySciDataType;

#define	STYLE_SCI_NORMAL	0
#define	STYLE_SCI_MARK		1
#define	STYLE_SCI_COMMENT	2

#define	MARKER_SCI_MARK		1
#define	MARKER_SCI_POS		2
#define	MARKER_BIT(x)		(1<<(x))

#define	STATE_SCI_NORMAL	0
#define	STATE_SCI_MARK		1
#define	STATE_SCI_COMMENT	2

#define	MARGIN_LINENUM		0
#define	MARGIN_POS			1
#define	MARGIN_MARK			2

/*	Xg{bNX̕AbZ[W	*/
#define	WM_SCI_RESTORE		(WM_APP+31)
/*
	eɑ
	wParam = MAKEWPARAM( tO, sԍ )
	lParam = Ŝ̍s or ݏĂsԍ
	tO = 0:Jn 1: 2:I
*/

/*	Lbg̐Fݒ肷	*/
#define	WM_SCI_UPDATE_CARET_COLOR	(WM_APP+32)

#ifdef	__cplusplus
extern "C" {
#endif

/*	Scintilla̍쐬	*/
extern	HWND	CreateMyScintilla( HWND hWndParent, UINT nCtrlID, LPCTSTR lpszDllPath );

/*	Scintilla̔j	*/
extern	BOOL	DestroyMyScintilla( HWND hWnd );

/*	TuNXvV[W	*/
extern	LRESULT	MYEXPORT	CALLBACK	MyScintillaWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

/*	Lbg_Ŏ̐ݒ	*/
extern	void	SetCaretPeriodMyScintilla( HWND hWnd, UINT uPeriod );

/*	tHgݒ	*/
extern	void	SetFontMyScintilla( HWND hWnd, HFONT hFont, HFONT hFontNewLine );

/*	Fݒ	*/
extern	void	SetColorMyScintilla( HWND hWnd );

/*	IvVݒ	*/
extern	void	SetOptionMyScintilla( HWND hWnd, BOOL bDiamond, BOOL bCtrlXC, BOOL bShowLineNum, BOOL bShowNewLine, TCHAR cNewLine, BOOL bMarkAsComment, BOOL bShowEdge, int nEdgeColumn );

/*	ʒmbZ[W	*/
extern	BOOL	NotifyProcMyScintilla( HWND hWnd, LPNMHDR pnmh, LpMarkCommentInfoType pInfo );

/*	t@C̓ǂݍ(O)	*/
extern	void	LoadFilePhase1MyScintilla( HWND hWnd );

/*	t@C̓ǂݍ(eACe)	*/
extern	BOOL	LoadFilePhase2MyScintilla( HWND hWnd, LPCTSTR lpszData, int nLen );

/*	t@C̓ǂݍ(㏈)	*/
extern	void	LoadFilePhase3MyScintilla( HWND hWnd, LpMarkCommentInfoType pInfo );

typedef	struct	tagCopyFromListBoxMyScintillaInfoType	{
	HWND	hWndFrom;
	HWND	hWndTo;
	int		nLineCnt;
	LpMarkCommentInfoType pInfo;
	void	(FAR* lpfnMessagePump)( HWND, LPMSG );
}	CopyFromListBoxMyScintillaInfoType, FAR* LpCopyFromListBoxMyScintillaInfoType;

/*	Xg{bNXRs[	*/
extern	BOOL	CopyFromListBoxMyScintilla( HWND hWnd, WPARAM wParam, LPARAM lParam );

/*	t@C̏o	*/
extern	BOOL	SaveFileMyScintilla( HWND hWnd, WPARAM wParam, LPARAM lParam );

/*	X^C	*/
extern	void	DoStylingMyScintilla( HWND hWnd, LpMarkCommentInfoType pInfo );

/*	Õ}[NT	*/
extern	int		SearchPrevMarkMyScintilla( HWND hWnd, int nLine );

/*	̃}[NT	*/
extern	int		SearchNextMarkMyScintille( HWND hWnd, int nLine );

/*	}[NȂTRUEԂ	*/
extern	BOOL	IsMarkMyScintilla( HWND hWnd, int nLine );

/*	RgȂTRUEԂ	*/
extern	BOOL	IsCommentMyScintilla( HWND hWnd, int nLine );

/*	e	*/
extern	void	EmptyMyScintilla( HWND hWnd );

/*	݂̍sԍ𓾂	*/
extern	int		GetCurrentLineMyScintilla( HWND hWnd );

/*	s𓾂	*/
extern	int		GetLineCntMyScintilla( HWND hWnd );

/*	TCYԂ	*/
extern	int		GetLengthMyScintilla( HWND hWnd );

/*	ẅʒuֈړ	*/
extern	void	DoMoveMyScintilla( HWND hWnd, int nLineNum, int nOfs );

#if 0
/*	ẅʒuֈړ	*/
extern	void	DoMove2MyScintilla( HWND hWnd, int nLineNum );

/*	̍sֈړ	*/
extern	void	DoMoveNextMyScintilla( HWND hWnd );
#endif

/*	eLXg擾	*/
extern	LPCTSTR	GetTextMyScintilla( HWND hWnd, int nLine, int* pLen );

/*	ReLXgj[̕\ʒu߂	*/
extern	void	GetContextMenuPosMyScintilla( HWND hWnd, int* x, int* y );

/*	ANZ[^	*/
extern	BOOL	TranslateAcceleratorMyScintilla( HWND hWndParent, HWND hWnd, LPMSG pMsg );

/*	}[NRs[	*/
extern	void	InsertMarkMyScintilla( HWND hWndTo, HWND hWndFrom, int nLineNum );

/*	Z[uẽobt@Ԃ	*/
extern	HGLOBAL	GetSaveBuffMyScintilla( HWND hWnd, LPDWORD lpdwLen );

/*	I͈͂̃eLXg擾	*/
extern	void	GetSelTextMyScintilla( HWND hWnd, LPTSTR lpszBuff, int nSize );

/*	O(Ɍ)	*/
extern	int		FindNextMyScintilla( HWND hWnd, UINT nFlag, LPCTSTR lpszText );

/*	(Ɍ)	*/
extern	int		FindPrevMyScintilla( HWND hWnd, UINT nFlag, LPCTSTR lpszText );

/*	Lbg\悤ɃXN[	*/
extern	void	ScrollCaretMyScintilla( HWND hWnd );

/*	I͈͂u	*/
extern	void	ReplaceSelMyScintilla( HWND hWnd, LPCTSTR lpszText );

/*	sɃ}[N}	*/
extern	void	InsertMarkTopMyScintilla( HWND hWnd, LpMarkCommentInfoType pInfo );

/*	sɃRg}	*/
extern	void	InsertCommentTopMyScintilla( HWND hWnd, LpMarkCommentInfoType pInfo );

/*	o[W̕擾	*/
extern	BOOL	GetDllVersionInfoMyScintilla( LPTSTR lpszString );



extern	BOOL	IsModifiedMyScintilla( HWND hWnd );		/*	XVĂ邩H	*/
extern	BOOL	CanUndoMyScintilla( HWND hWnd );		/*	Undoł邩H	*/
extern	BOOL	CanRedoMyScintilla( HWND hWnd );		/*	Redoł邩H	*/
extern	BOOL	IsSelectedMyScintilla( HWND hWnd );		/*	IĂ邩H	*/
extern	BOOL	CanPasteMyScintilla( HWND hWnd );		/*	\tł邩H	*/
extern	void	DoUndoMyScintilla( HWND hWnd );			/*	Undo	*/
extern	void	DoRedoMyScintilla( HWND hWnd );			/*	Redo	*/
extern	void	DoCutMyScintilla( HWND hWnd );			/*	؂	*/
extern	void	DoCopyMyScintilla( HWND hWnd );			/*	Rs[	*/
extern	void	DoPasteMyScintilla( HWND hWnd );		/*	\t	*/
extern	void	DoTopMyScintilla( HWND hWnd );			/*	擪	*/
extern	void	DoLastMyScintilla( HWND hWnd );			/*	Ō	*/
extern	void	DoDelMyScintilla( HWND hWnd );			/*	폜	*/
extern	void	DoPrevMyScintilla( HWND hWnd );			/*	O	*/
extern	void	DoNextMyScintilla( HWND hWnd );			/*		*/
extern	void	DoNewLineMyScintilla( HWND hWnd );		/*	s	*/
extern	void	DoRollUpMyScintilla( HWND hWnd );		/*	[Abv	*/
extern	void	DoRollDownMyScintilla( HWND hWnd );		/*	[_E	*/
extern	void	DoSelectAllMyScintilla( HWND hWnd );	/*	ׂđI	*/
extern	void	DoBackMyScintilla( HWND hWnd );			/*	obNXy[X	*/

#ifdef	__cplusplus
}
#endif

#endif	/*	MYSCI_H	*/
