/*--------------------------------------------------------------*\
		module	:	SetupDlg.c
		purpose :	X-Send ݒ_CAO
		author	:	_@ Kengo Jinno
		create	:	2001/09/18
		update	:	2001/09/26
					2001/11/13	CreateMyToolTip()̈ǉɑΉ
					2002/03/06	SetupDlgInfo::bMarkAsComment ǉ
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"SetupDlg.h"
#include	"resource.h"
#include	"ToolTip.h"
#include	"MyDDE.h"

static	void	NEAR	InitDialogProc( HWND hDlg, LpSetupDlgInfo pInfo )
{
	/*	\E	*/
	CheckDlgButton( hDlg, IDC_CHECK_DIAMOND, pInfo->bDiamondCursor ? 1 : 0 );
	CheckDlgButton( hDlg, IDC_CHECK_CTRL_XC, pInfo->bCtrlXCCursor ? 1 : 0 );
	EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CTRL_XC ), pInfo->bDiamondCursor );
	CheckDlgButton( hDlg, IDC_CHECK_CARET_RIGHT, pInfo->bCaretRight ? 1 : 0 );
	EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CARET_RIGHT ), !pInfo->bViewMode );
	CheckDlgButton( hDlg, IDC_CHECK_MARK_AS_COMMENT, pInfo->bMarkAsComment ? 1 : 0 );
	/*	o@	*/
	{
		/*	T[rXꗗR{{bNXɓ	*/
		int		i;
		LPCTSTR	p;
		for( i = 0; i < pInfo->nDdeServiceArry; i++ ) {
			p = pInfo->szDdeServiceArray[i];
			if( p != NULL ) {
				SendDlgItemMessage( hDlg, IDC_COMBO_DDE_SERVICE_NAME, CB_ADDSTRING, 0, (LPARAM)p );
			}
		}
		SendDlgItemMessage( hDlg, IDC_COMBO_DDE_SERVICE_NAME, CB_LIMITTEXT, _MAX_FNAME, 0 );
		SetDlgItemText( hDlg, IDC_COMBO_DDE_SERVICE_NAME, pInfo->szDdeServerName );
	}
	CheckRadioButton( hDlg, IDC_RADIO_DDE, IDC_RADIO_EDITSEND, pInfo->bUseDde ? IDC_RADIO_DDE : IDC_RADIO_EDITSEND );
	if( !pInfo->bCanUseEditSend ) {
		/*	EditSend.dllgȂ̂ŁA𖳌ɂ	*/
		EnableWindow( GetDlgItem( hDlg, IDC_RADIO_EDITSEND ), FALSE );
		EnableWindow( GetDlgItem( hDlg, IDC_BTN_EDITSEND_WINDOW ), FALSE );
		EnableWindow( GetDlgItem( hDlg, IDC_BTN_EDITSEND_MESSAGE ), FALSE );
	} else {
		if( pInfo->bUseDde ) {
			EnableWindow( GetDlgItem( hDlg, IDC_BTN_EDITSEND_WINDOW ), FALSE );
			EnableWindow( GetDlgItem( hDlg, IDC_BTN_EDITSEND_MESSAGE ), FALSE );
		} else {
			EnableWindow( GetDlgItem( hDlg, IDC_STATIC_DDE_SERVICE_NAME ), FALSE );
			EnableWindow( GetDlgItem( hDlg, IDC_COMBO_DDE_SERVICE_NAME ), FALSE );
			EnableWindow( GetDlgItem( hDlg, IDC_BTN_DDE_SEARCH ), FALSE );
		}
	}
	/*	IMS	*/
	CheckDlgButton( hDlg, IDC_CHECK_USE_IMS, pInfo->bUseImsApi ? 1 : 0 );
	SendDlgItemMessage( hDlg, IDC_EDIT_NOTIFY_IMS, EM_LIMITTEXT, _MAX_PATH, 0 );
	SetDlgItemText( hDlg, IDC_EDIT_NOTIFY_IMS, pInfo->szHelpMe );
	EnableWindow( GetDlgItem( hDlg, IDC_STATIC_NOTIFY_IMS ), pInfo->bUseImsApi );
	EnableWindow( GetDlgItem( hDlg, IDC_EDIT_NOTIFY_IMS ), pInfo->bUseImsApi );
	
	/*	c[`bv	*/
	if( pInfo->bNoTooltip ) {
		pInfo->hWndToolTip = NULL;
	} else {
		ToolTipDataType	ti[] = {
			{ IDC_RADIO_DDE,              IDS_TIPS_RADIO_DDE              },
			{ IDC_RADIO_EDITSEND,         IDS_TIPS_RADIO_EDITSEND         },
			{ IDC_COMBO_DDE_SERVICE_NAME, IDS_TIPS_COMBO_DDE_SERVICE_NAME },
			{ IDC_BTN_DDE_SEARCH,         IDS_TIPS_BTN_DDE_SEARCH         },
			{ IDC_BTN_EDITSEND_WINDOW,    IDS_TIPS_BTN_EDITSEND_WINDOW    },
			{ IDC_BTN_EDITSEND_MESSAGE,   IDS_TIPS_BTN_EDITSEND_MESSAGE   },
			{ IDC_CHECK_DIAMOND,          IDS_TIPS_CHECK_DIAMOND          },
			{ IDC_CHECK_CTRL_XC,          IDS_TIPS_CHECK_CTRL_XC          },
			{ IDC_CHECK_CARET_RIGHT,      IDS_TIPS_CHECK_CARET_RIGHT      },
			{ IDC_CHECK_USE_IMS,          IDS_TIPS_CHECK_USE_IMS          },
			{ IDC_EDIT_NOTIFY_IMS,        IDS_TIPS_EDIT_NOTIFY_IMS        },
			{ IDC_CHECK_MARK_AS_COMMENT,  IDS_TIPS_MARK_AS_COMMENT        },
		};
		const	int		nCnt = sizeof(ti) / sizeof(ToolTipDataType);
		pInfo->hWndToolTip = CreateMyToolTip( hDlg, ti, nCnt, pInfo->bMultilineTip, TRUE );
	}
}

BOOL	MYEXPORT	CALLBACK	SetupDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( uMsg == WM_INITDIALOG ) {
		LpSetupDlgInfo	p = (LpSetupDlgInfo)lParam;
		InitDialogProc( hDlg, p );
		SetWindowLong( hDlg, DWL_USER, (long)lParam );
		return TRUE;
	} else if( uMsg == WM_COMMAND ) {
		LpSetupDlgInfo	pInfo = (LpSetupDlgInfo)GetWindowLong( hDlg, DWL_USER );
		WORD	wNotifyCode, wID;
		HWND	hWndCtrl;
#ifdef	WIN32
		wNotifyCode = HIWORD(wParam);
		wID = LOWORD(wParam);
		hWndCtrl = (HWND)lParam;
#else
		wNotifyCode = HIWORD(lParam);
		wID = wParam;
		hWndCtrl = (HWND)LOWORD(lParam);
#endif
		if( wNotifyCode == BN_CLICKED ) {
			if( wID == IDOK ) {
				GetDlgItemText( hDlg, IDC_COMBO_DDE_SERVICE_NAME, pInfo->szDdeServerName, _MAX_FNAME );
				GetDlgItemText( hDlg, IDC_EDIT_NOTIFY_IMS, pInfo->szHelpMe, _MAX_PATH );
				EndDialog( hDlg, IDOK );
			} else if( wID == IDCANCEL ) {
				EndDialog( hDlg, IDCANCEL );
			} else if( wID == IDC_CHECK_DIAMOND ) {
				pInfo->bDiamondCursor = ( IsDlgButtonChecked( hDlg, IDC_CHECK_DIAMOND ) == 1 );
				EnableWindow( GetDlgItem( hDlg, IDC_CHECK_CTRL_XC ), pInfo->bDiamondCursor );
			} else if( wID == IDC_CHECK_CTRL_XC ) {
				pInfo->bCtrlXCCursor = ( IsDlgButtonChecked( hDlg, IDC_CHECK_CTRL_XC ) == 1 );
			} else if( wID == IDC_CHECK_CARET_RIGHT ) {
				pInfo->bCaretRight = ( IsDlgButtonChecked( hDlg, IDC_CHECK_CARET_RIGHT ) == 1 );
			} else if( wID == IDC_CHECK_MARK_AS_COMMENT ) {
				pInfo->bMarkAsComment = ( IsDlgButtonChecked( hDlg, IDC_CHECK_MARK_AS_COMMENT ) == 1 );
			} else if( wID == IDC_RADIO_DDE ) {
				pInfo->bUseDde = TRUE;
				EnableWindow( GetDlgItem( hDlg, IDC_STATIC_DDE_SERVICE_NAME ), TRUE );
				EnableWindow( GetDlgItem( hDlg, IDC_COMBO_DDE_SERVICE_NAME ), TRUE );
				EnableWindow( GetDlgItem( hDlg, IDC_BTN_DDE_SEARCH ), TRUE );
				EnableWindow( GetDlgItem( hDlg, IDC_BTN_EDITSEND_WINDOW ), FALSE );
				EnableWindow( GetDlgItem( hDlg, IDC_BTN_EDITSEND_MESSAGE ), FALSE );
			} else if( wID == IDC_RADIO_EDITSEND ) {
				pInfo->bUseDde = FALSE;
				EnableWindow( GetDlgItem( hDlg, IDC_STATIC_DDE_SERVICE_NAME ), FALSE );
				EnableWindow( GetDlgItem( hDlg, IDC_COMBO_DDE_SERVICE_NAME ), FALSE );
				EnableWindow( GetDlgItem( hDlg, IDC_BTN_DDE_SEARCH ), FALSE );
				EnableWindow( GetDlgItem( hDlg, IDC_BTN_EDITSEND_WINDOW ), TRUE );
				EnableWindow( GetDlgItem( hDlg, IDC_BTN_EDITSEND_MESSAGE ), TRUE );
			} else if( wID == IDC_BTN_DDE_SEARCH ) {
				HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hDlg, GWL_HINSTANCE );
				TCHAR	buff[ _MAX_PATH ];
				LPCTSTR	ret;
				HCURSOR	hCursor = SetCursor( LoadCursor( NULL, IDC_WAIT ) );
				GetDlgItemText( hDlg, IDC_COMBO_DDE_SERVICE_NAME, buff, _MAX_FNAME );
				if( CheckDDEServer( pInfo->hWndParent, pInfo->pDdeInfo, buff ) ) {
					ret = buff;
				} else {
					ret = SearchDDEServer( pInfo->hWndParent, pInfo->pDdeInfo, pInfo->szDdeServiceArray, pInfo->nDdeServiceArry );
				}
				SetCursor( hCursor );
				if( ret != NULL ) {
					TCHAR	msg[ _MAX_PATH ], fmt[ _MAX_PATH ];
					LoadString( hInstance, IDS_DDE_FOUND, fmt, _MAX_PATH );	//	"u%sv܂B"
					wsprintf( msg, fmt, ret );
					MessageBox( hDlg, msg, pInfo->lpszTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONINFORMATION|MB_OK );
					SetDlgItemText( hDlg, IDC_COMBO_DDE_SERVICE_NAME, ret );
				} else {
					TCHAR	msg[ _MAX_PATH ];
					LoadString( hInstance, IDS_DDE_NOT_FOUND, msg, _MAX_PATH );	//	"܂"
					MessageBox( hDlg, msg, pInfo->lpszTitle, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONSTOP|MB_OK );
				}
			} else if( wID == IDC_BTN_EDITSEND_WINDOW ) {
				(pInfo->pEdsApiInfo->lpEdsInitWindowDialog)( hDlg, &(pInfo->hWndTarget) );
			} else if( wID == IDC_BTN_EDITSEND_MESSAGE ) {
				(pInfo->pEdsApiInfo->lpEdsInitParamDialog)( hDlg, &(pInfo->EdsParam) );
			} else if( wID == IDC_CHECK_USE_IMS ) {
				pInfo->bUseImsApi = ( IsDlgButtonChecked( hDlg, IDC_CHECK_USE_IMS ) == 1 );
				EnableWindow( GetDlgItem( hDlg, IDC_STATIC_NOTIFY_IMS ), pInfo->bUseImsApi );
				EnableWindow( GetDlgItem( hDlg, IDC_EDIT_NOTIFY_IMS ), pInfo->bUseImsApi );
			}
		}
	} else if( uMsg == WM_NOTIFY ) {
		LpSetupDlgInfo	pInfo = (LpSetupDlgInfo)GetWindowLong( hDlg, DWL_USER );
		LPNMHDR	pnmh = (LPNMHDR)lParam;
		if( pnmh->code == TTN_NEEDTEXT && !pInfo->bNoTooltip ) {
			LPTOOLTIPTEXT	lptip = (LPTOOLTIPTEXT)pnmh;
			if( pnmh->hwndFrom == pInfo->hWndToolTip ) {
				HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hDlg, GWL_HINSTANCE );
				NeedTextMyToolTip( pInfo->hWndToolTip, hInstance, lptip );
			}
		}
	} else if( uMsg == WM_DESTROY ) {
		LpSetupDlgInfo	pInfo = (LpSetupDlgInfo)GetWindowLong( hDlg, DWL_USER );
		/*	c[`bv폜	*/
		if( pInfo->hWndToolTip != NULL ) {
			DestroyMyToolTip( pInfo->hWndToolTip );
			pInfo->hWndToolTip = NULL;
		}
	}
	return FALSE;
}
