/*--------------------------------------------------------------*\
		module	:	StatBar.c
		purpose :	X-Send Xe[^Xo[
		author	:	_@ Kengo Jinno
		create	:	2001/09/06
		update	:	2001/10/17
					2001/11/01	IsBadReadPtr() IsBadCodePtr()
								ĝ߂B(Win2K/XP)
					2002/04/12	ShowSimpleTextStatusBar()
								ExitSimpleTextStatusBar()ǉ
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"StatBar.h"
#include	"resource.h"

static	LPCTSTR		lpszPropertyName = _T("afe8d0c0-adc9-11d5-af4f-00c0ca10a705");

#define	ICON_CX		16
#define	ICON_CY		16

/*	Xe[^Xo[̍쐬	*/
HWND	CreateStatusBar( HWND hWndParent, UINT nCtrlID, BOOL bShow, BOOL bNoTooltip )
{
	HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hWndParent, GWL_HINSTANCE );
	DWORD	dwStyle;
	HWND	hWnd;
	
	dwStyle = WS_CHILD|WS_CLIPSIBLINGS|SBARS_SIZEGRIP|CCS_BOTTOM;
	hWnd = CreateWindowEx( 0, STATUSCLASSNAME, NULL, dwStyle,
		0, 0, 0, 0, hWndParent, (HMENU)nCtrlID, hInstance, NULL );
	
	if( hWnd != NULL ) {
		LpStatusBarInfoType	p;
		p = (LpStatusBarInfoType)GlobalAlloc( GPTR, sizeof(StatusBarInfoType) );
		if( p == NULL ) {
			DestroyWindow( hWnd );
			return( NULL );
		}
		p->hWndToolTip = NULL;
		p->bNoTooltip = bNoTooltip;
		p->szText1[0] = _T('\0');
		p->bShowText = TRUE;
		p->eIconState = eIconDdeNg;
		p->hIconState = NULL;
		p->szText2[0] = _T('\0');
		p->dwTotalSize = 0;
		p->dwCurrentPos = 0;
		/*	vpeBɃZbg	*/
		SetProp( hWnd, lpszPropertyName, (HANDLE)p );
		/*	TuNX	*/
		p->lpfnOldWndProc = (WNDPROC)SetWindowLong( hWnd, GWL_WNDPROC, (LONG)MyStatusBarWndProc );
		/*	c[`bv	*/
		if( !bNoTooltip ) {
			ToolTipDataType	ti[] = {
				{ 0, 0 },
				{ 1, 1 },
			};
			const	int		nCnt = sizeof(ti) / sizeof(ToolTipDataType);
			p->hWndToolTip = CreateMyStatusBarToolTip( hWnd, ti, nCnt, FALSE );
		}
		
		if( bShow ) {
			ShowWindow( hWnd, SW_SHOW );
		}
		AutoSizeStatusBar( hWnd );
	}
	
	return( hWnd );
}

/*	Xe[^Xo[̔j	*/
BOOL	DestroyStatusBar( HWND hWnd )
{
	BOOL	ret = TRUE;
	if( IsWindow( hWnd ) ) {
		LpStatusBarInfoType	p = (LpStatusBarInfoType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			/*	c[`bv	*/
			if( p->hWndToolTip != NULL && IsWindow( p->hWndToolTip ) ) {
				DestroyMyToolTip( p->hWndToolTip );
				p->hWndToolTip = NULL;
			}
			/*	TuNX	*/
			if( p->lpfnOldWndProc != NULL ) {
				SetWindowLong( hWnd, GWL_WNDPROC, (LONG)p->lpfnOldWndProc );
				p->lpfnOldWndProc = NULL;
			}
			/*	vpeB폜	*/
			RemoveProp( hWnd, lpszPropertyName );
			GlobalFree( (HGLOBAL)p );
		}
		/*	p	*/
		ret = DestroyWindow( hWnd );
	}
	return ret;
}

/*	TuNXvV[W	*/
LRESULT	MYEXPORT	CALLBACK	MyStatusBarWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	LpStatusBarInfoType	p = (LpStatusBarInfoType)GetProp( hWnd, lpszPropertyName );
	if( p == NULL || p->lpfnOldWndProc == NULL ) {
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}
	if( uMsg == WM_NOTIFY ) {
		int		idCtrl = (int)wParam;
		LPNMHDR	pnmh = (LPNMHDR)lParam;
		if( pnmh->code == TTN_NEEDTEXT && !p->bNoTooltip ) {
			if( pnmh->hwndFrom == p->hWndToolTip ) {
				/*	c[`bṽeLXg	*/
				LPTOOLTIPTEXT	lptip = (LPTOOLTIPTEXT)pnmh;
				lptip->hinst = NULL;
				if( lptip->hdr.idFrom == 0 ) {
					/*	P	*/
					lptip->lpszText = p->szText1;
				} else if( lptip->hdr.idFrom == 1 ) {
					/*	Q	*/
					int		nLen = 0;
					TCHAR	fmt[ 80 ], msg[ 80 ];
					UINT	uID;
					HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hWnd, GWL_HINSTANCE );
					switch( p->eIconState ) {
					case eIconDdeNg:		uID = IDS_TIPS_SB_DDE_NG;		break;	//	"DDEްȂ"
					case eIconEditSendNg:	uID = IDS_TIPS_SB_EDITSEND_NG;	break;	//	"M注޳s"
					case eIconDdeStop:		uID = IDS_TIPS_SB_DDE_STOP;		break;	//	"o֎~"
					default:				uID = IDS_TIPS_SB_DDE_GO;		break;	//	"o"
					}
					LoadString( hInstance, uID, msg, 80 );
					LoadString( hInstance, IDS_TIPS_SB_STATE_FMT, fmt, 80 );	//	":%s / "
					nLen += wsprintf( p->szTooltipText+nLen, fmt, msg );
					LoadString( hInstance, IDS_TIPS_SB_METHOD_FMT, fmt, 80 );	//	"o@:%s"
					nLen += wsprintf( p->szTooltipText+nLen, fmt, p->szText2 );
					lptip->lpszText = p->szTooltipText;
				}
			}
		}
	} else if( uMsg == WM_CONTEXTMENU ) {
		POINT	pt;
		RECT	rect;
		pt.x = LOWORD( lParam );
		pt.y = HIWORD( lParam );
		ScreenToClient( hWnd, &pt );
		SendMessage( hWnd, SB_GETRECT, 1, (LPARAM)&rect );	/*	QH	*/
		if( PtInRect( &rect, pt ) ) {
			//	eɗ
		} else {
			return 0;
		}
	} else if( uMsg == WM_LBUTTONDBLCLK ) {
		POINT	pt;
		RECT	rect1, rect2;
		pt.x = LOWORD( lParam );
		pt.y = HIWORD( lParam );
		SendMessage( hWnd, SB_GETRECT, 0, (LPARAM)&rect1 );	/*	PH	*/
		SendMessage( hWnd, SB_GETRECT, 1, (LPARAM)&rect2 );	/*	QH	*/
		if( PtInRect( &rect1, pt ) ) {
			PostMessage( GetParent( hWnd ), WM_SB_DBLCLK1, 0, 0 );
		} else if( PtInRect( &rect2, pt ) ) {
			PostMessage( GetParent( hWnd ), WM_SB_DBLCLK2, 0, 0 );
		}
	} else if( uMsg == WM_DESTROY ) {
		RemoveProp( hWnd, lpszPropertyName );
	}
//	if( IsBadReadPtr( &(p->lpfnOldWndProc), sizeof(p->lpfnOldWndProc) ) || IsBadCodePtr( (FARPROC)p->lpfnOldWndProc ) ) {
//		return DefWindowProc( hWnd, uMsg, wParam, lParam );
//	}
	return CallWindowProc( p->lpfnOldWndProc, hWnd, uMsg, wParam, lParam );
}

/*	TCY	*/
void	AutoSizeStatusBar( HWND hWnd )
{
	if( IsWindow( hWnd ) && IsWindowVisible( hWnd ) ) {
		LpStatusBarInfoType	p = (LpStatusBarInfoType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			int		sb_size[2];
			RECT	rect;
			int		nWidth;
			
			SendMessage( hWnd, WM_SIZE, 0, 0 );	/*	wParam,lParam̓E\ǁAv	*/
			
			/*	Q̋̃TCY	*/
			/*	̋悪2/3AE̋1/3Ƃ	*/
			GetClientRect( hWnd, &rect );
			nWidth = rect.right - rect.left;
			sb_size[0] = nWidth * 2 / 3;
			sb_size[1] = -1;	/*	cS	*/
			SendMessage( hWnd, SB_SETPARTS, 2, (LPARAM)sb_size );
			
			/*	I[i[`悷	*/
			SendMessage( hWnd, SB_SETTEXT, 0|SBT_OWNERDRAW, (LPARAM)p );
			SendMessage( hWnd, SB_SETTEXT, 1|SBT_OWNERDRAW, (LPARAM)p );
			
			if( p->hWndToolTip != NULL && IsWindow( p->hWndToolTip ) ) {
				int		i;
				TOOLINFO	ti;
				
				ZeroMemory( &ti, sizeof(ti) );
				ti.cbSize = gbIe3Later ? sizeof(ti) : sizeof(oldTOOLINFO);
				
				for( i = 0; i < 2; i++ ) {
					ti.hwnd = hWnd;
					ti.uId = i;
					if( SendMessage( p->hWndToolTip, TTM_GETTOOLINFO, 0, (LPARAM)&ti ) ) {
						SendMessage( hWnd, SB_GETRECT, i, (LPARAM)&(ti.rect) );
						ti.uFlags = TTF_SUBCLASS;
						ti.hinst = NULL;
						ti.lpszText = LPSTR_TEXTCALLBACK;
						SendMessage( p->hWndToolTip, TTM_SETTOOLINFO, 0, (LPARAM)&ti );
					}
				}
			}
			
//			InvalidateRect( hWnd, NULL, TRUE );
			/*	łƂc	*/
		}
	}
}

/*	eLXg\(P)	*/
void	ShowTextStatusBar( HWND hWnd, LPCTSTR lpszText )
{
	if( IsWindow( hWnd ) ) {
		LpStatusBarInfoType	p = (LpStatusBarInfoType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			lstrcpyn( p->szText1, lpszText, MAX_STATUS_BAR_TEXT );
			SendMessage( hWnd, SB_SETTEXT, 0|SBT_OWNERDRAW, (LPARAM)p );
			SendMessage( hWnd, SB_SETTEXT, 1|SBT_OWNERDRAW, (LPARAM)p );
		}
	}
}

/*	eLXg\(Q)	*/
void	SetTextStatusBar( HWND hWnd, LPCTSTR lpszText )
{
	if( IsWindow( hWnd ) ) {
		LpStatusBarInfoType	p = (LpStatusBarInfoType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			p->bShowText = TRUE;
			lstrcpyn( p->szText2, lpszText, MAX_STATUS_BAR_TEXT );
			SendMessage( hWnd, SB_SETTEXT, 0|SBT_OWNERDRAW, (LPARAM)p );
			SendMessage( hWnd, SB_SETTEXT, 1|SBT_OWNERDRAW, (LPARAM)p );
		}
	}
}

/*	ACR\	*/
void	SetIconStatusBar( HWND hWnd, IconStateType state )
{
	if( IsWindow( hWnd ) ) {
		LpStatusBarInfoType	p = (LpStatusBarInfoType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			UINT		uID = 0;
			HINSTANCE	hInstance = (HINSTANCE)GetWindowLong( hWnd, GWL_HINSTANCE );
			p->eIconState = state;
			switch( p->eIconState ) {
			case eIconDdeNg:		uID = IDI_ICON_DDE_NG;			break;
			case eIconDdeStop:		uID = IDI_ICON_DDE_STOP;		break;
			case eIconDdeGo:		uID = IDI_ICON_DDE_GO;			break;
			case eIconEditSendOk:	uID = IDI_ICON_EDITSEND_OK;		break;
			case eIconEditSendNg:	uID = IDI_ICON_EDITSEND_NG;		break;
			}
			if( uID == 0 ) {
				p->hIconState = NULL;
			} else {
				p->hIconState = (HICON)LoadImage( hInstance, MAKEINTRESOURCE(uID), IMAGE_ICON, ICON_CX, ICON_CY, 0 );
			}
			SendMessage( hWnd, SB_SETTEXT, 0|SBT_OWNERDRAW, (LPARAM)p );
			SendMessage( hWnd, SB_SETTEXT, 1|SBT_OWNERDRAW, (LPARAM)p );
		}
	}
}

/*	is󋵂\	*/
void	SetProgressSizeStatusBar( HWND hWnd, DWORD dwSize )
{
	if( IsWindow( hWnd ) ) {
		LpStatusBarInfoType	p = (LpStatusBarInfoType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			p->bShowText = FALSE;
			p->dwTotalSize = dwSize;
			p->dwCurrentPos = 0;
			SendMessage( hWnd, SB_SETTEXT, 0|SBT_OWNERDRAW, (LPARAM)p );
			SendMessage( hWnd, SB_SETTEXT, 1|SBT_OWNERDRAW, (LPARAM)p );
		}
	}
}

void	SetProgressPosStatusBar( HWND hWnd, DWORD dwPos )
{
	if( IsWindow( hWnd ) ) {
		LpStatusBarInfoType	p = (LpStatusBarInfoType)GetProp( hWnd, lpszPropertyName );
		if( p != NULL ) {
			p->bShowText = FALSE;
			p->dwCurrentPos = dwPos;
			if( p->dwCurrentPos > p->dwTotalSize ) {
				p->dwCurrentPos = p->dwTotalSize;
			}
			SendMessage( hWnd, SB_SETTEXT, 0|SBT_OWNERDRAW, (LPARAM)p );
			SendMessage( hWnd, SB_SETTEXT, 1|SBT_OWNERDRAW, (LPARAM)p );
		}
	}
}

/*	R}h̐\	*/
void	ShowSimpleTextStatusBar( HWND hWnd, LPCTSTR lpszText )
{
	if( IsWindow( hWnd ) ) {
		SendMessage( hWnd, SB_SIMPLE, TRUE, 0 );
		SendMessage( hWnd, SB_SETTEXT, 255|SBT_NOBORDERS, (LPARAM)lpszText );
		InvalidateRect( hWnd, NULL, TRUE );
	}
}

void	ExitSimpleTextStatusBar( HWND hWnd )
{
	if( IsWindow( hWnd ) ) {
		SendMessage( hWnd, SB_SIMPLE, FALSE, 0 );
	}
}

/*	I[i[`	*/
void	DrawStatusBarItem( HWND hWnd, LPDRAWITEMSTRUCT lpDrawItemStruct )
{
	RECT	rect = lpDrawItemStruct->rcItem;
	HDC		hDC = lpDrawItemStruct->hDC;
	UINT	nItem = lpDrawItemStruct->itemID;
	DWORD	dwItemData = lpDrawItemStruct->itemData;
	
	if( dwItemData != 0 ) {
		LpStatusBarInfoType	pInfo = (LpStatusBarInfoType)dwItemData;
		if( nItem == 0 || ( nItem == 1 && pInfo->bShowText ) ) {
			/*	ʏ̕`	*/
			COLORREF	colOldBack = SetBkColor( hDC, GetSysColor( COLOR_BTNFACE ) );
			COLORREF	colOldText = SetTextColor( hDC, GetSysColor( COLOR_BTNTEXT ) );
			int			nOldBkMode = SetBkMode( hDC, TRANSPARENT );
			LPCTSTR		lpszText = ( nItem == 0 ) ? pInfo->szText1 : pInfo->szText2;
			if( nItem == 1 && pInfo->hIconState != NULL ) {
				/*	Q̃ACR	*/
				int		x = rect.left;
				int		y = rect.top;
				y += ( ( rect.bottom - rect.top ) - ICON_CY ) / 2;	/*	㉺Z^O	*/
				DrawIconEx( hDC, x, y, pInfo->hIconState, ICON_CX, ICON_CY, 0, NULL, DI_NORMAL );
				rect.left += ICON_CX;
			}
			DrawStatusText( hDC, &rect, lpszText, SBT_NOBORDERS );
			SetBkMode( hDC, nOldBkMode );
			SetTextColor( hDC, colOldText );
			SetBkColor( hDC, colOldBack );
		} else if( nItem == 1 && !pInfo->bShowText ) {
			/*	is(vOXo[)	*/
			RECT	rc;
			int		nPos;
			/*	rect̓TCYObv̗̈܂ł̂ŁA	*/
			SendMessage( hWnd, SB_GETRECT, 1, (LPARAM)&rc );
			IntersectRect( &rect, &rect, &rc );
			/*	ǂ܂Ői񂾂HvZ	*/
			nPos = rect.left;
			if( pInfo->dwTotalSize > 0 ) {
				nPos += MulDiv( rect.right - rect.left, pInfo->dwCurrentPos, pInfo->dwTotalSize );
			}
			/*	ς񂾕̕`(ʏ͐)	*/
			if( nPos > rect.left ) {
				int		nRight = rect.right;
				rect.right = nPos;
				FillRect( hDC, &rect, GetSysColorBrush( COLOR_HIGHLIGHT ) );
				rect.right = nRight;
			}
			/*	c̕̕`(ʏ͊DF)	*/
			rect.left = nPos;
			FillRect( hDC, &rect, GetSysColorBrush( COLOR_BTNFACE ) );
		}
	}
}
