/*--------------------------------------------------------------*\
		module	:	XSD-sock.c
		purpose :	X-Send f[ \Pbg
		author	:	_@ Kengo Jinno
		create	:	2001/09/13
		update	:	2001/10/02
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"XSD-sock.h"
#include	"XSD.h"
#include	"XSD-API.h"

/*	Wsock32.dll[h	*/
static	BOOL	LoadWinsock( NpXsdSocketInfoType pInfo )
{
	pInfo->hInstWsock32 = LoadLibraryEx( _T("WSOCK32.DLL"), NULL, 0 );
	if( pInfo->hInstWsock32 == NULL ) {
		return( FALSE );
	}
	
	/*	DLL̃GNX|[g֐ւ̃|C^擾	*/
	pInfo->lpfn_WSAStartup      = (LP_FUNC_WSASTARTUP)     GetProcAddress( pInfo->hInstWsock32, _T("WSAStartup") );
	pInfo->lpfn_WSACleanup      = (LP_FUNC_WSACLEANUP)     GetProcAddress( pInfo->hInstWsock32, _T("WSACleanup") );
	pInfo->lpfn_gethostname     = (LP_FUNC_GETHOSTNAME)    GetProcAddress( pInfo->hInstWsock32, _T("gethostname") );
	pInfo->lpfn_gethostbyname   = (LP_FUNC_GETHOSTBYNAME)  GetProcAddress( pInfo->hInstWsock32, _T("gethostbyname") );
	pInfo->lpfn_inet_ntoa       = (LP_FUNC_INET_NTOA)      GetProcAddress( pInfo->hInstWsock32, _T("inet_ntoa") );
	pInfo->lpfn_ntohl           = (LP_FUNC_NTOHL)          GetProcAddress( pInfo->hInstWsock32, _T("ntohl") );
	pInfo->lpfn_htonl           = (LP_FUNC_HTONL)          GetProcAddress( pInfo->hInstWsock32, _T("htonl") );
	pInfo->lpfn_socket          = (LP_FUNC_SOCKET)         GetProcAddress( pInfo->hInstWsock32, _T("socket") );
	pInfo->lpfn_bind            = (LP_FUNC_BIND)           GetProcAddress( pInfo->hInstWsock32, _T("bind") );
	pInfo->lpfn_htons           = (LP_FUNC_HTONS)          GetProcAddress( pInfo->hInstWsock32, _T("htons") );
	pInfo->lpfn_WSAGetLastError = (LP_FUNC_WSAGETLASTERROR)GetProcAddress( pInfo->hInstWsock32, _T("WSAGetLastError") );
	pInfo->lpfn_closesocket     = (LP_FUNC_CLOSESOCKET)    GetProcAddress( pInfo->hInstWsock32, _T("closesocket") );
	pInfo->lpfn_WSAAsyncSelect  = (LP_FUNC_WSAASYNCSELECT) GetProcAddress( pInfo->hInstWsock32, _T("WSAAsyncSelect") );
	pInfo->lpfn_ioctlsocket     = (LP_FUNC_IOCTLSOCKET)    GetProcAddress( pInfo->hInstWsock32, _T("ioctlsocket") );
	pInfo->lpfn_sendto          = (LP_FUNC_SENDTO)         GetProcAddress( pInfo->hInstWsock32, _T("sendto") );
	pInfo->lpfn_recvfrom        = (LP_FUNC_RECVFROM)       GetProcAddress( pInfo->hInstWsock32, _T("recvfrom") );
	pInfo->lpfn_setsockopt      = (LP_FUNC_SETSOCKOPT)     GetProcAddress( pInfo->hInstWsock32, _T("setsockopt") );
	
	if( pInfo->lpfn_WSAStartup      == NULL ||
		pInfo->lpfn_WSACleanup      == NULL ||
		pInfo->lpfn_gethostname     == NULL ||
		pInfo->lpfn_gethostbyname   == NULL ||
		pInfo->lpfn_inet_ntoa       == NULL ||
		pInfo->lpfn_ntohl           == NULL ||
		pInfo->lpfn_htonl           == NULL ||
		pInfo->lpfn_socket          == NULL ||
		pInfo->lpfn_bind            == NULL ||
		pInfo->lpfn_htons           == NULL ||
		pInfo->lpfn_WSAGetLastError == NULL ||
		pInfo->lpfn_closesocket     == NULL ||
		pInfo->lpfn_WSAAsyncSelect  == NULL ||
		pInfo->lpfn_ioctlsocket     == NULL ||
		pInfo->lpfn_sendto          == NULL ||
		pInfo->lpfn_recvfrom        == NULL ||
		pInfo->lpfn_setsockopt      == NULL ) {
		FreeLibrary( pInfo->hInstWsock32 );
		pInfo->hInstWsock32 = NULL;
	}
	
	return( pInfo->hInstWsock32 != NULL );
}


/*		*/
BOOL	XsdSocketInit( NpXsdSocketInfoType pInfo, HWND hWndNotify )
{
	pInfo->ulAddr = INADDR_NONE;
	pInfo->uSockAsyncMsg = WM_XSD_SOCK_ASYNC_MSG;
	pInfo->hSocket = INVALID_SOCKET;
	pInfo->bIsLoaded = LoadWinsock( pInfo );
	if( pInfo->bIsLoaded ) {
		BOOL	ret = FALSE;
		if( (pInfo->lpfn_WSAStartup)( MAKEWORD(1, 1), &(pInfo->wsd) ) == 0 ) {
			TCHAR		szName[ _MAX_PATH ];
			ret = FALSE;
			if( (pInfo->lpfn_gethostname)( szName, _MAX_PATH ) == 0 ) {
				PHOSTENT	hostinfo;
				if( ( hostinfo = (pInfo->lpfn_gethostbyname)(szName) ) != NULL ) {
					if( hostinfo->h_addr_list != NULL && hostinfo->h_addr_list[0] != NULL ) {
						PIN_ADDR	pin_addr;
						pin_addr = (PIN_ADDR)(hostinfo->h_addr_list[0]);
						pInfo->ulAddr = (pInfo->lpfn_ntohl)(pin_addr->s_addr);
						ret = TRUE;
					}
				}
			}
			if( ret ) {
				pInfo->hSocket = (pInfo->lpfn_socket)( PF_INET, SOCK_DGRAM, 0 );
				ret = ( pInfo->hSocket != INVALID_SOCKET );
				/*	bind	*/
				if( ret ) {
					SOCKADDR_IN	sockAddr;
					ZeroMemory( &sockAddr, sizeof(sockAddr) );
					sockAddr.sin_family = AF_INET;
					sockAddr.sin_addr.s_addr = (pInfo->lpfn_htonl)( INADDR_ANY );	/*	pInfo->ulAddr	*/
					sockAddr.sin_port = (pInfo->lpfn_htons)( (USHORT)(pInfo->uPort) );
					ret = ( (pInfo->lpfn_bind)( pInfo->hSocket, (SOCKADDR*)&sockAddr, sizeof(sockAddr) ) == 0 );
				}
				/*	setsockopt	*/
				if( ret ) {
					BOOL	bOpt = TRUE;	/*	u[hLXg	*/
					ret = ( (pInfo->lpfn_setsockopt)( pInfo->hSocket, SOL_SOCKET, SO_BROADCAST, (char *)&bOpt, sizeof(bOpt) ) == 0 );
				}
				/*	WSAAsyncSelect	*/
				if( ret ) {
					ret = ( (pInfo->lpfn_WSAAsyncSelect)( pInfo->hSocket, hWndNotify, pInfo->uSockAsyncMsg, FD_READ ) == 0 );
				}
			}
			if( !ret ) {
				if( pInfo->hSocket != INVALID_SOCKET ) {
					(pInfo->lpfn_closesocket)( pInfo->hSocket );
					pInfo->hSocket = INVALID_SOCKET;
				}
				(pInfo->lpfn_WSACleanup)();
			}
		}
		if( !ret ) {
			FreeLibrary( pInfo->hInstWsock32 );
			pInfo->hInstWsock32 = NULL;
			pInfo->bIsLoaded = FALSE;
			pInfo->ulAddr = INADDR_NONE;
		}
	}
	return( FALSE );
}

/*	I	*/
void	XsdSocketQuit( NpXsdSocketInfoType pInfo )
{
	if( pInfo->bIsLoaded ) {
		if( pInfo->hSocket != INVALID_SOCKET ) {
			(pInfo->lpfn_closesocket)( pInfo->hSocket );
			pInfo->hSocket = INVALID_SOCKET;
		}
		(pInfo->lpfn_WSACleanup)();
		FreeLibrary( pInfo->hInstWsock32 );
		pInfo->hInstWsock32 = NULL;
	}
	pInfo->bIsLoaded = FALSE;
	pInfo->ulAddr = INADDR_NONE;
}

/*	񓯊ʒmbZ[W̏	*/
void	XsdSocketAsyncMsgProc( HWND hWnd, WPARAM wParam, LPARAM lParam, NpXsdSocketInfoType pInfo )
{
	NpXsdInfo	p = GetXsdInfo( hWnd );
	SOCKET	hSocket = (SOCKET)wParam;
	if( WSAGETSELECTEVENT(lParam) == FD_READ ) {
		if( hSocket == pInfo->hSocket ) {
			/*	܂AX^bÑobt@ɎM	*/
			XsdApiInfoType	buff;
			int		nLen = sizeof(XsdApiInfoType);
			if( (pInfo->lpfn_recvfrom)( hSocket, (char*)&buff, nLen, 0, NULL, NULL ) == nLen ) {
				if( pInfo->bLocalSocket || buff.ulAddr != pInfo->ulAddr ) {
					/*
						E[Jɂ\PbgŒʒm(fobOp)
						EʂPC(IPAhX)͂
						̂ǂ炩̏ꍇB
					*/
					/*	Rs[āA[`LbN	*/
					CopyMemory( &(p->XsdApiInfo), &buff, nLen );
					PostMessage( hWnd, WM_XSD_SOCKET_MSG, 0, 0 );
				}
			}
		}
	}
}

/*	u[hLXg	*/
void	XsdSocketBroadcast( NpXsdSocketInfoType pInfo, LPBYTE pData, DWORD dwSize )
{
	if( pInfo->bIsLoaded && pInfo->hSocket != INVALID_SOCKET ) {
		SOCKADDR_IN	sockAddr;
		ZeroMemory( &sockAddr, sizeof(sockAddr) );
		sockAddr.sin_family = AF_INET;
		sockAddr.sin_addr.s_addr = (pInfo->lpfn_htonl)( pInfo->bNoBroadcast ? pInfo->ulAddr : INADDR_BROADCAST );
		sockAddr.sin_port = (pInfo->lpfn_htons)( (USHORT)(pInfo->uPort) );
		(pInfo->lpfn_sendto)( pInfo->hSocket, pData, dwSize, 0, (struct sockaddr*)&sockAddr, sizeof(sockAddr) );
	}
}
