/*--------------------------------------------------------------*\
		module	:	XSD.c
		purpose :	X-Send f[ C
		author	:	_@ Kengo Jinno
		create	:	2001/09/11
		update	:	2001/10/16
\*--------------------------------------------------------------*/

#include	"PCH.h"
#include	"XSD.h"

#if		defined(__BORLANDC__)
#pragma resource "XSD.res"
#endif

const	TCHAR	BASED_CODE	szXsdWndClass[] = _T("X-Send-Daemon-FrameWndClass");	/*	EBhENX	*/
const	TCHAR	BASED_CODE	szXsdAppName[] = _T("X-Send Daemon");			/*	LvV	*/
const	TCHAR	BASED_CODE	szXsdMutexName[] = _T("XSD-2ee49c80-a6c5-11d5-af4f-00c0ca10a705");	/*	dNh~	*/
const	TCHAR	BASED_CODE	szTaskbarCreated[] = _T("TaskbarCreated");		/*	^XNo[č\zꂽ	*/
const	TCHAR	BASED_CODE	szXsWndClass[] = _T("X-Send-FrameWndClass");	/*	X-Send̃EBhENX	*/

#define		VERSION		_T("1.0(32)")

/* INIt@C̃ZNVEGg[	*/
static	const	TCHAR	BASED_CODE	lpszProfileSection[] = _T("X-Send-Daemon");
static	const	TCHAR	BASED_CODE	lpszProfilePortEntry[] = _T("Port");
static	const	TCHAR	BASED_CODE	lpszProfileNoBroadcastEntry[] = _T("NoBroadcast");
static	const	TCHAR	BASED_CODE	lpszProfileLocalSocketEntry[] = _T("LocalSocket");
static	const	TCHAR	BASED_CODE	lpszProfileNoHighPriorityEntry[] = _T("NoHighPriority");

/*	o[W_CAO	*/
static	void	ShowVersion( HWND hWnd, HINSTANCE hInstance )
{
	TCHAR	buff[ 256 ], msg[ 256 ];
	static	const	TCHAR	BASED_CODE	szVersion[] = VERSION;
	LoadString( hInstance, IDS_VERSION, buff, 255 );
	wsprintf( msg, buff, (LPCTSTR)szXsdAppName, (LPCTSTR)szVersion );
	MessageBox( hWnd, msg, szXsdAppName, MB_APPLMODAL|MB_DEFBUTTON1|MB_ICONINFORMATION|MB_OK );
}

/*	INIt@C̓ǂݍ	*/
static	void	NEAR	ReadProfile( NpXsdInfo p, LPCTSTR lpszFile )
{
	p->uPort = GetPrivateProfileInt( lpszProfileSection, lpszProfilePortEntry, XSD_PORT, lpszFile );
	p->bNoBroadcast = GetPrivateProfileInt( lpszProfileSection, lpszProfileNoBroadcastEntry, p->bNoBroadcast, lpszFile );
	p->bLocalSocket = GetPrivateProfileInt( lpszProfileSection, lpszProfileLocalSocketEntry, p->bLocalSocket, lpszFile );
	p->bNoHighPriority = GetPrivateProfileInt( lpszProfileSection, lpszProfileNoHighPriorityEntry, p->bNoHighPriority, lpszFile );
}

/*	WM_CREATE	*/
LRESULT	NEAR	CreateProc( HWND hWnd, LPCREATESTRUCT pcs )
{
	NpXsdInfo	p;
	
	SetXsdInfo( hWnd, NULL );
	p = (NpXsdInfo)LocalAlloc( LPTR, sizeof(XsdInfo) );
	if( p == NULL ) {
		return -1L;
	}
	p->hInstance = pcs->hInstance;
	
	{	/*	INIt@Č	*/
		TCHAR	buff[_MAX_PATH];
		LPSTR	q, r, s;
		static	const	TCHAR	BASED_CODE	szExtension[] = _T(".ini");
		GetModuleFileName( p->hInstance, buff, _MAX_PATH );
		q = r = s = buff;
		while( *r != _T('\0') ) {
#ifdef	WIN32
			if( IsDBCSLeadByte( *r ) ) {
#else
			if( iskanji( *r ) && iskanji2( *(r+1) ) ) {
			/*	3.1ȂIsDBCSLeadByte()Ă񂾂	*/
#endif
				r++;
			} else if( *r == _T('.') ) {
				s = r;	//	Ō'.'w
			} else if( *r == _T('\\') ) {
				q = r;	//	Ō'\\'w
			}
			r++;
		}
#ifdef	WIN32
		{
			WIN32_FIND_DATA	wfd;
			HANDLE	h = FindFirstFile( buff, &wfd );
			if( h != INVALID_HANDLE_VALUE ) {
				FindClose( h );
				/*	t@Cǉ	*/
				*(q+1) = _T('\0');
				lstrcat( buff, wfd.cFileName );
				s = r = q;
				while( *r != _T('\0') ) {
					if( IsDBCSLeadByte( *r ) ) {
						r++;
					} else if( *r == _T('.') ) {
						s = r;	//	Ō'.'w
					}
					r++;
				}
			}
		}
#endif
		/*	INIt@C	*/
		lstrcpy( p->szProfile, buff );
		p->szProfile[ s-buff ] = _T('\0');
		lstrcat( p->szProfile, szExtension );
//		/*	Ot@C̃fBNǧ	*/
//		*(q+1) = _T('\0');
//		lstrcpy( p->szLogPath, buff );
	}
	
	/*	fobOp	*/
	p->bNoBroadcast = FALSE;
	p->bLocalSocket = FALSE;
	p->bNoHighPriority = FALSE;
	
	/*	API֌W	*/
	p->uXsdApiMsg = 0;
	ZeroMemory( &(p->XsdApiInfo), sizeof(XsdApiInfoType) );
	p->lpszXsWndClass = szXsWndClass;
	p->bMustQuit = FALSE;
	p->lpszSendDataBuff = NULL;
	p->lpszWritePos = NULL;
	p->dwSendDataBuffSize = 0;
	p->szFileSend[0] = _T('\0');
	p->hProcess = GetCurrentProcess();
	p->dwPriority = GetPriorityClass( p->hProcess );
	if( pcs->lpCreateParams != NULL ) {
		p->uXsdApiMsg = atoi( (LPCTSTR)pcs->lpCreateParams );
	}
	
	/*	INIt@C̓ǂݍ	*/
	ReadProfile( p, p->szProfile );
	
	p->XsdSocketInfo.uPort = p->uPort;
	p->XsdSocketInfo.bNoBroadcast = p->bNoBroadcast;
	p->XsdSocketInfo.bLocalSocket = p->bLocalSocket;
	
	/*	\Pbg	*/
	XsdSocketInit( &(p->XsdSocketInfo), hWnd );
	
	/*	^XNgC֌W	*/
	ZeroMemory( &(p->nid), sizeof(NOTIFYICONDATA) );
	p->nid.cbSize = sizeof(NOTIFYICONDATA);
	p->nid.hWnd = hWnd;
	p->nid.uID = XSD_TRAY_ID;
	p->nid.uFlags = NIF_ICON|NIF_MESSAGE|NIF_TIP;
	p->nid.uCallbackMessage = WM_XSD_TRAY_ICON;
	p->nid.hIcon = (HICON)LoadImage( p->hInstance, MAKEINTRESOURCE(IDI_ICON_XSD), IMAGE_ICON, 16, 16, 0 );
	p->bInTray = FALSE;
//	p->hMenuPopup = LoadMenu( hInstance, MAKEINTRESOURCE( IDR_MENU_POPUP ) );
	p->uTaskbarCreatedMsg = RegisterWindowMessage( szTaskbarCreated );
	
	SetXsdInfo( hWnd, p );
	
	/*	gCɊi[	*/
	if( !p->bInTray ) {
		GetWindowText( hWnd, p->nid.szTip, sizeof(p->nid.szTip) );
		if( Shell_NotifyIcon( NIM_ADD, &(p->nid) ) ) {
			p->bInTray = TRUE;
		}
	}
	
	/*	Xbh̗D揇ʂPグ	*/
	SetThreadPriority( GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL );
	/*
		펞F9
		]F14
	*/
	
	return( 0L );
}

/*	WM_COPYDATA	*/
BOOL	NEAR	CopyDataProc( HWND hWnd, HWND hWndFrom, PCOPYDATASTRUCT pcds )
{
	BOOL	ret = FALSE;
	NpXsdInfo	p = GetXsdInfo( hWnd );
	if( p != NULL ) {
		/*	܂NXmF	*/
		TCHAR	szClassName[ _MAX_PATH ];
		if( GetClassName( hWndFrom, szClassName, _MAX_PATH ) > 0 ) {
			if( lstrcmp( szClassName, p->lpszXsWndClass ) == 0 ) {
				/*	X-Send瑗Ă̂łB	*/
				/*	ɓe`FbNB	*/
				if( p->uXsdApiMsg != 0 && p->uXsdApiMsg == pcds->dwData ) {
					if( pcds->cbData == sizeof( XsdApiInfoType ) ) {
						CopyMemory( &(p->XsdApiInfo), pcds->lpData, pcds->cbData );
						p->XsdApiInfo.ulAddr = p->XsdSocketInfo.ulAddr;
						PostMessage( hWnd, WM_XSD_LOCAL_MSG, 0, 0 );
						ret = TRUE;
					}
				}
			}
		}
	}
	return( ret );
}

/*	WM_DESTROY	*/
LRESULT	NEAR	DestroyProc( HWND hWnd )
{
	NpXsdInfo	p = GetXsdInfo( hWnd );
	if( p != NULL ) {
		/*	\Pbg	*/
		XsdSocketQuit( &(p->XsdSocketInfo) );
		/*	gCɓĂ鎞̏I	*/
		if( p->bInTray ) {
			Shell_NotifyIcon( NIM_DELETE, &(p->nid) );
			p->bInTray = FALSE;
		}
		/*	]ꎞt@C̍폜	*/
		if( p->lpszSendDataBuff != NULL ) {
			GlobalFree( (HGLOBAL)p->lpszSendDataBuff );
			p->lpszSendDataBuff = NULL;
		}
		p->lpszWritePos = NULL;
		p->dwSendDataBuffSize = 0;
		if( p->szFileSend[0] != _T('\0') ) {
			DeleteFile( p->szFileSend );
			p->szFileSend[0] = _T('\0');
		}
		LocalFree( (HLOCAL)p );
		SetXsdInfo( hWnd, NULL );
	}
	PostQuitMessage( 0 );
	return 0L;
}

/*	EBhEvV[W	*/
LRESULT	MYEXPORT	CALLBACK	XsdWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	NpXsdInfo	p = GetXsdInfo( hWnd );
	switch( uMsg ) {
	case WM_CREATE:
		return CreateProc( hWnd, (LPCREATESTRUCT)lParam );
	case WM_COPYDATA:
		if( CopyDataProc( hWnd, (HWND)wParam, (PCOPYDATASTRUCT)lParam ) ) {
			return (LRESULT)TRUE;
		}
		break;
	case WM_XSD_LOCAL_MSG:
		XsdLocalMsgProc( hWnd );
		return 0L;
	case WM_XSD_SOCKET_MSG:
		XsdSocketMsgProc( hWnd );
		return 0L;
	case WM_XSD_TRAY_ICON:
		if( p != NULL && wParam == XSD_TRAY_ID ) {
			switch( lParam ) {
			case WM_LBUTTONDOWN:
			case WM_RBUTTONDOWN:
				SetForegroundWindow( GetLastActivePopup( hWnd ) );
				if( IsWindowEnabled( hWnd ) ) {
					ShowVersion( hWnd, p->hInstance );
				}
				PostMessage( hWnd, WM_NULL, 0, 0 );
				break;
			}
		}
		break;
	case WM_DESTROY:
		return DestroyProc( hWnd );
	default:
		if( p != NULL && p->XsdSocketInfo.bIsLoaded && uMsg == p->XsdSocketInfo.uSockAsyncMsg ) {
			/*	\Pbgɉ	*/
			XsdSocketAsyncMsgProc( hWnd, wParam, lParam, &(p->XsdSocketInfo) );
		}
		if( p != NULL && p->uTaskbarCreatedMsg != 0 && uMsg == p->uTaskbarCreatedMsg ) {
			if( p->bInTray && !Shell_NotifyIcon( NIM_MODIFY, &(p->nid) ) ) {
				/*	gCč\zꂽēo^	*/
				Shell_NotifyIcon( NIM_ADD, &(p->nid) );
			}
		}
		break;
	}
	return DefWindowProc( hWnd, uMsg, wParam, lParam );
}

/*	C	*/
int		WINAPI	WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow )
{
	MSG		msg;
	HWND	hWnd;
	HANDLE	hMutex;
	
	hWnd = FindWindow( szXsdWndClass, NULL );
	if( hWnd != NULL ) {
		UINT	uMsg = RegisterWindowMessage( szTaskbarCreated );
		PostMessage( hWnd, uMsg, 0, 0 );
	}
	
	if( lpszCmdLine == NULL || lpszCmdLine[0] == _T('\0') ) {
		ShowVersion( NULL, hInstance );
		return FALSE;
	}
	
	/*	dÑ`FbN	*/
	hMutex = CreateMutex( NULL, FALSE, szXsdMutexName );
	if( hMutex == NULL || GetLastError() == ERROR_ALREADY_EXISTS ) {
		if( hMutex != NULL ) {
			CloseHandle( hMutex );
		}
		MessageBeep( UINT_MAX );
		return FALSE;
	}
	
	if( hPrevInstance == NULL ) {
		WNDCLASS	wc;
		wc.style = CS_DBLCLKS;
		wc.lpfnWndProc = XsdWndProc;
		wc.cbClsExtra = 0;
		wc.cbWndExtra = XSD_EXTRA_BYTES;
		wc.hInstance = hInstance;
		wc.hIcon = LoadIcon( hInstance, MAKEINTRESOURCE( IDI_ICON_XSD ) );
		wc.hCursor = LoadCursor( NULL, IDC_ARROW );
		wc.hbrBackground = (HBRUSH)( COLOR_WINDOW+1 );
		wc.lpszMenuName = NULL;
		wc.lpszClassName = szXsdWndClass;
		if( !RegisterClass( &wc ) ) {
			if( hMutex != NULL ) {
				CloseHandle( hMutex );
			}
			return FALSE;
		}
	}
	InitCommonControls();
	/*	CEBhE̍쐬	*/
	hWnd = CreateWindow( szXsdWndClass, szXsdAppName,
		WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,
		CW_USEDEFAULT, CW_USEDEFAULT, 0, 0,
		NULL, NULL, hInstance, lpszCmdLine );
	if( hWnd == NULL ) {
		if( hMutex != NULL ) {
			CloseHandle( hMutex );
		}
		return FALSE;
	}
	if( FindWindow( szXsWndClass, NULL ) == NULL ) {
		/*	X-SendȂPƋNH	*/
		ShowWindow( hWnd, nCmdShow );
		UpdateWindow( hWnd );
	}
	
	while( GetMessage( &msg, NULL, 0, 0 ) ) {
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	
	if( hMutex != NULL ) {
		CloseHandle( hMutex );
	}
	
	return (int)msg.wParam;
}
